##############################################################################
#
# Copyright (c) 2005-2006 TINY SPRL. (http://tiny.be) All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import time
from report import report_sxw
from tools import amount_to_text_en


class report_trial_balance(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(report_trial_balance, self).__init__(cr, uid, name, context)
        self.sum_debit = 0.0
        self.sum_credit = 0.0
        self.localcontext.update({
            'time': time,
            'convert':self.convert,
            'get_date':self.get_date,
            'sum_debit': self._sum_debit,
            'sum_credit': self._sum_credit,
            'debit': self.make_debit,
            'credit': self.make_credit,
        })

    def convert(self,amount, cur):
        amt_en = amount_to_text_en.amount_to_text(amount,'en',cur);
        return amt_en
    
    def get_date(self):
        fiscalyear_obj = self.pool.get('account.fiscalyear')
        fiscalyear = fiscalyear_obj.find(self.cr, self.uid)
        date_start =  fiscalyear_obj.browse(self.cr, self.uid, fiscalyear).date_start
        date_start = time.strftime('%d-%b-%Y', time.strptime( date_start, '%Y-%m-%d'))
        return date_start
    
    def make_debit(self, debit, type):
        if type == 'dr':
            self.sum_debit += debit
        return
    
    def make_credit(self, credit, type):
        if type == 'cr':
            self.sum_credit += credit
        return
    
    def _sum_credit(self):
        return self.sum_credit
    
    def _sum_debit(self):
        return self.sum_debit

report_sxw.report_sxw(
    'report.trial.balance.sheet',
    'account.account',
    'addons/account_voucher/report/report_trial_balance.rml',
    parser=report_trial_balance,header=False
)