import time
import netsvc
from osv import fields, osv
import ir
import pooler
import mx.DateTime
from mx.DateTime import RelativeDateTime

from tools import config

class Account(osv.osv):
        _inherit = "account.account"
   
        def _balance(self, cr, uid, ids, field_name, arg, context={}):
            ids2 = self.search(cr, uid, [('parent_id', 'child_of', ids)])
            ids2 = {}.fromkeys(ids + ids2).keys()
            acc_set = ",".join(map(str, ids2))
            query = self.pool.get('account.move.line')._query_get(cr, uid,
                    context=context)
            cr.execute(("SELECT a.id, " \
                        "SUM((COALESCE(l.debit, 0) - COALESCE(l.credit, 0))) " \
                    "FROM account_account a " \
                        "LEFT JOIN account_move_line l " \
                        "ON (a.id=l.account_id) " \
                    "WHERE a.type != 'view' " \
                        "AND a.id IN (%s) " \
                        "AND " + query + " " \
                        "AND a.active " \
                    "GROUP BY a.id") % (acc_set, ))
            res = {}
            for account_id, sum in cr.fetchall():
                res[account_id] = round(sum,2)
            cr.execute("SELECT a.id, a.company_id " \
                    "FROM account_account a " \
                    "WHERE id IN (%s)" % acc_set)
            resc = dict(cr.fetchall())
            cr.execute("SELECT id, currency_id FROM res_company")
            rescur = dict(cr.fetchall())
    
            for id in ids:
                ids3 = self.search(cr, uid, [('parent_id', 'child_of', [id])])
                to_currency_id = rescur[resc[id]]
                for idx in ids3:
                    if idx <> id:
                        res.setdefault(id, 0.0)
                        if resc[idx]<>resc[id] and resc[idx] and resc[id]:
                            from_currency_id = rescur[resc[idx]]
                            res[id] += self.pool.get('res.currency').compute(cr,
                                    uid, from_currency_id, to_currency_id,
                                    res.get(idx, 0.0), context=context)
                        else:
                            res[id] += res.get(idx, 0.0)
            for id in ids:
                open=self.browse(cr, uid, id, context)
                if open.type in('receivable','asset', 'cash','expense'):
                    res[id] = round(res.get(id,0.0), 2) + open.open_bal
                elif open.type in ('payable','income','equity','tax'):
                    total=(open.open_bal)*(-1)
                    res[id] = round(res.get(id,0.0), 2) + total
                else:
                    res[id] = round(res.get(id,0.0), 2)
            return res
        
        
        def _diff(self, cr, uid, ids, field_name, arg, context={}):

            res={}
            dr_total=0.0
            cr_total=0.0
            difference=0.0
            for id in ids:
                open=self.browse(cr, uid, id, context)

                if open.type1 == 'dr':
                    dr_total+=open.open_bal

                elif open.type1 == 'cr':
                    cr_total+=open.open_bal

                else:
                    dr_total=0.0
                    cr_total=0.0
            difference=dr_total-cr_total

            for id in ids:
                res[id]=difference

            return res

        _columns = {
            'open_bal' : fields.float('Opening Balance',digits=(16,2)),
            'diff' : fields.function(_diff, digits=(16,2),method=True,string='Difference of Opening Bal.'),
            'type1':fields.selection([('dr','Debit'),('cr','Credit'),('none','None')], 'Dr/Cr',store=True),
            'balance': fields.function(_balance, digits=(16,2), method=True,store=True, string='Closing Balance'),


    }
        
    
        def onchange_type(self, cr, uid, ids,type,type1):
            if not type:
                return {'value' : {}}
            if type in ('receivable','cash','asset','expense'):
                type1 = 'dr'
            elif type in ('payable','equity','income','tax') : 
                type1 = 'cr'
            else:
                type1 = 'none'
          
            return {
                'value' : {'type1' : type1}
        }

Account()
