# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2004-2006 TINY SPRL. (http://tiny.be) All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import time
from report import report_sxw
import xml
import rml_parse
import pooler
import copy
import re
#
# Repport for payment line
#
class payment_linec2c(report_sxw.rml_parse):
	_name = 'report.payment.linec2c'
	gadr_cpt = 0

	def __init__(self, cr, uid, name, context):
		super(payment_linec2c, self).__init__(cr,uid, name, context)
		user_obj=pooler.get_pool(cr.dbname).get('res.users')
		company=user_obj.browse(cr, uid, uid).company_id
		self.localcontext.update({
			'time': time,
			'company_name':company.name,
			'company_addr':company.partner_id.address[0].street,
			'company_addr2':company.partner_id.address[0].street2,
			'company_zip':company.partner_id.address[0].zip,
			'company_phone':company.partner_id.address[0].phone,
			'company_city':company.partner_id.address[0].city,
			'company_email':company.partner_id.address[0].email,
			'lines' : self.lines,
			'comma_me' : self.comma_me,
			'strip_name' : self._strip_name,
		})
		
		self.context = context
		
		
	def lines(self,ids={}):
		
		retour_unsort = self.get_result(ids)
		
		return retour_unsort
	
	
	def _ellipsis(self, string, maxlen=100, ellipsis = '...'):
		ellipsis = ellipsis or ''
		try:
			return string[:maxlen - len(ellipsis) ] + (ellipsis, '')[len(string) < maxlen]
		except Exception, e:
			return False
	def _strip_name(self, name, maxlen=50):
		return self._ellipsis(name, maxlen, ' ...')
		
	def comma_me(self,amount):
		if  type(amount) is float :
			amount = str('%.2f'%amount)
		else :
			amount = str(amount)
		if (amount == '0'):
		     return ' '
		orig = amount
		new = re.sub("^(-?\d+)(\d{3})", "\g<1>'\g<2>", amount)
		if orig == new:
			return new
		else:
			return self.comma_me(new)
	
	def get_result(self,line_join_table_ids={}):
		if not line_join_table_ids:
			return []
		result = []
		#payments = self.pool.get('payment.line').browse(self.cr, self.uid, ids.id,self.context)
		##  
		for payment_line_id in line_join_table_ids.id:
			payment_line = self.pool.get('payment.line').browse(self.cr, self.uid, payment_line_id,self.context)
			res = {
				'partner_name': payment_line.partner_id.name,
				'bank_account' : payment_line.bank_id.name,
				'reference': payment_line.reference,
				'value_date' : payment_line.value_date,
				'amount' : payment_line.amount,
				'due_date': payment_line.due_date,
				'amount_currency' : payment_line.amount_currency,
				'currency_code' : payment_line.currency.code
			}
			result.append(res)
		return result
	

report_sxw.report_sxw('report.payment.linec2c', 'payment.order','addons/c2c_account_payment/payment_order.rml', parser=payment_linec2c, header=False)


