# -*- coding: utf-8 -*- 
##############################################################################
#
# Copyright (c) 2004 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import osv, fields
import time
from mx import DateTime

import netsvc

#--------------------------------------------------------------------------------------------------------
# Modifiy line expense for obligatory analytic account
#--------------------------------------------------------------------------------------------------------
class hr_expense_line (osv.osv):
	_name = 'hr.expense.line'
	_inherit = "hr.expense.line"
	_columns  = {
		'analytic_account': fields.many2one('account.analytic.account','Analytic account', required=True),
	}
hr_expense_line()

#--------------------------------------------------------------------------------------------------------
# Invoici line => must have analytic account
#--------------------------------------------------------------------------------------------------------
class account_invoice_line(osv.osv):
	_name = "account.invoice.line"
	_inherit = "account.invoice.line"
	_columns = {
		'account_analytic_id':  fields.many2one('account.analytic.account', 'Analytic Account', required=True),
	}
account_invoice_line()

#--------------------------------------------------------------------------------------------------------
# Add column for link to project.project
#--------------------------------------------------------------------------------------------------------
class account_analytic_account(osv.osv):
	_name = "account.analytic.account"
	_inherit = "account.analytic.account"
	_columns = {
		'contact_id' : fields.many2one('res.partner.address', 'Contact', required=True),
		'partner_id' : fields.many2one('res.partner', 'Associated partner',required=True),
		'pricelist_id' : fields.many2one('product.pricelist', 'Sale Pricelist',required=True),
	}
	def onchange_partner(self, cr, uid, id, partner_id):
		invoice_addr_id = False
		contact_addr_id = False

		opt = [('uid', str(uid))]
		if partner_id:
			opt.insert(0, ('id', partner_id))
			res = self.pool.get('res.partner').address_get(cr, uid, [partner_id], ['contact', 'invoice'])
			contact_addr_id = res['contact']
			invoice_addr_id = res['invoice']

		result = {'value': {
			'contact_id': invoice_addr_id or contact_addr_id,
		}}
		return result
	
	def copy(self, cr, uid, id, default=None, context={}):
		"""Override copy method to disable recursiv copy"""
		account = self.browse(cr, uid, id, context=context)
		if not default:
			default = {}
		default.update({
			'line_ids':[],
			'child_ids':[],
			'code':'to change',})
		return super(account_analytic_account, self).copy(cr, uid, id, default, context=context)
		

account_analytic_account()

class hr_timesheet_sheet(osv.osv):
	""" set default name of the time sheet sheet"""
	_inherit = "hr_timesheet_sheet.sheet"

	_columns = {
		'name': fields.char('Description', size=64, select=1),
		}
		
	_defaults = {
		'name': lambda *a: time.strftime('%Y/%U'),
	}
	
hr_timesheet_sheet()
