# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2004-2006 TINY SPRL. (http://tiny.be) All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import time
from report import report_sxw
import xml
import rml_parse
import copy
from operator import itemgetter

class account_analytic_chart(rml_parse.rml_parse):
	_name = 'report.account.analytic.chartc2c'
	
	def preprocess(self, objects, data, ids):
		new_ids = []
		if (data['model'] == 'account.analytic.account'):
			new_ids = ids
		else:
			new_ids.append(data['form']['Account_list'])
			
			objects = self.pool.get('account.analytic.account').browse(self.cr, self.uid, new_ids)
		
		super(account_analytic_chart, self).preprocess(objects, data, new_ids)	
	
	def __init__(self, cr, uid, name, context):
		super(account_analytic_chart, self).__init__(cr, uid, name, context)
		self.localcontext.update({
			'time': time,
			'lines': self.lines,
		})
		self.context = context
		

	def lines(self,ids={},data={},done=None, level=1):
		##
		
		self.max_level = data['form']['level_required']
		##
		retour_unsort = self.get_result(ids,done,1,data)
		return retour_unsort
	
	
	def get_result(self,ids={},done=None,level=1,data=None):
		
		if not ids:
			ids = self.ids
		if not ids:
			return []
		if not done:
			done={}
		result = []
		#
		#
		
		if self.max_level < level:
			return result
		#
		#
		
		
		accounts = self.pool.get('account.analytic.account').browse(self.cr, self.uid, ids,self.context)
		def cmp_code(x, y):
			return cmp(x.code, y.code)
		accounts.sort(cmp_code)
		for account in accounts:
			if account.id in done:
				continue
			done[account.id] = 1
			res = {
				'code': account.code,
				'name' : account.name,
				'type': 1,
				'level': '_'*(level-1)*2,
				'customer_name': account.partner_id and account.partner_id.name or '',
				'project_manager' : account.user_id and account.user_id.name or '',
			}
			## We will now test that we have specified an account state (open,close,etc...)
			if (data['form']['account_status']) :
				## We will test if the account state is equal to the current account
				if (data['form']['account_status'] == account.state):
					result.append(res)
			else:
				result.append(res)

			if account.child_ids:
				ids2 = [(x.code,x.id) for x in account.child_ids]
				ids2.sort()
				result += self.get_result([x[1] for x in ids2], done,level+1,data)
		return result

	def max_level_search(self,account_list):
		result = sorted(account_list, key=itemgetter('level'))
		if (result):
			return result[len(result)-1]['level']
		else:
			return 0
#report_sxw.report_sxw('report.account.account.balance', 'account.account', 'addons/account/report/account_balance.rml', parser=account_balance, header=False)
report_sxw.report_sxw('report.c2c_analytic_chart.account_analytic_chart', 'account.analytic.account','addons/c2c_fanalytic_chart/account_analytic_chart.rml', parser=account_analytic_chart, header=False)


