##############################################################################
#
# Copyright (c) Camptocamp (http://www.camptocamp.com) All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import wizard
#from copy import copy
import pooler
import time
from tools.misc import UpdateableStr
from account.project import project

FORM = UpdateableStr()




_account_fields = {
        #'project_chief': {'string':'Account manager', 'type':'many2many', 'relation':'res.users'},
        'level_required': {'string':'Level Required', 'type':'integer'},
}

account_form = '''<?xml version="1.0"?>
<form string="Select parent account">
	<field name="Account_list" colspan="4"/>
</form>'''

account_fields = {
	'Account_list': {'string':'Account', 'type':'many2one', 'relation':'account.analytic.account', 'required':True},
}



class wizard_account_analytic_chart(wizard.interface):
    
    
    def _check_path(self, cr, uid, data, context):
            if data['model'] == 'account.analytic.account':
                    return 'account_restriction'
            else:
                    return 'account_selection'

    def _get_defaults(self, cr, uid, data, context):
        ## Get the company id of the current user
        #
        
        user_obj=pooler.get_pool(cr.dbname).get('res.users')
        company=user_obj.browse(cr, uid, uid).company_id
        company_id = company.id
        ## Search all account manager
        cr.execute("select distinct(user_id) from account_analytic_account where company_id = " + str(company_id) + " ")
        account_manager = cr.fetchall() or None
        account_manager = map(lambda x : x[0] , account_manager)
        ## we will get the fild selection vallue of state of object account.analytic.account
        pp = project.account_analytic_account._columns
        _account_fields['account_status'] = {'string':"Display Project state:",'type':'selection','selection': pp['state'].selection }
        ##
        ## we will get the field selection value 
        Test = '''<?xml version="1.0"?>
                 <form string="timesheet Status" >
                            <field name="level_required"/>
                            <newline/>
                            <field name="account_status"/>
                 </form>'''
        FORM.string = Test
        return data['form']

    states = {
        'init': {
            'actions': [],
            'result': {'type':'choice','next_state':_check_path}
        },
        'account_selection': {
            'actions': [],
            'result': {'type':'form', 'arch':account_form,'fields':account_fields, 'state':[('end','Cancel'),('account_restriction','Print')]}
        },

        'account_restriction' : {
            'actions' : [_get_defaults], 
            'result' : {'type':'form', 'arch':FORM, 'fields':_account_fields, 'state': [('end','Cancel'),('print','Print Status')]},
        },
        'print': {
            'actions': [],
            'result': {'type':'print', 'report':'c2c_analytic_chart.account_analytic_chart', 'state':'end'}
        }
       
    }
    
    
wizard_account_analytic_chart('c2c_analytic_chart.analytic_chart_wizard');    
