# -*- coding: utf-8 -*- 
##############################################################################
#
# Copyright (c) 2004 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import osv, fields
import time
from mx import DateTime

import netsvc


# class myChar(fields.char):
# 	def __init__(self, string, size, **args):
# 		super(myChar, self).__init__(string, 256, **args)
#--------------------------------------------------------------------------------------------------------
# By default enable cancelleing entries on account journal
#--------------------------------------------------------------------------------------------------------
class account_journal(osv.osv):
	_name = "account.journal"
	_inherit = "account.journal"

	_defaults = {
		'update_posted': lambda *a: 1,
	}
account_journal()

class account_account(osv.osv):
	_inherit = "account.account"
	
	def init(self, cr):
		super(account_account,self).init(cr)
		try:
			cr.execute("ALTER TABLE account_account ADD CONSTRAINT unique_code_key UNIQUE (code,company_id);")
			cr.commit()
		except Exception:
			print("WARNING : Can t Apply ALTER TABLE account_account ADD CONSTRAINT unique_code_key UNIQUE (code,company_id);")
			cr.rollback()
account_account()
#--------------------------------------------------------------------------------------------------------
# Adresse contact, split name in fct => first name + last name, recode name get and name search !
#--------------------------------------------------------------------------------------------------------
# class res_partner(osv.osv):
# 	_name = "res.partner"
# 	_inherit = "res.partner"
# 	
# 
# 	def name_search(self, cr, user, obj, name, args):
# 		if not args[0]:
# 			arg=['','','']
# 		else :
# 			arg = args[0]
# 		cr.execute("""select id from res_partner where name ilike '%s%%'"""%(arg[2],arg[2])) 
# 		
# 		 to_ascii(name,'UNICODE') LIKE '%olo%'
# 		
# 		res = cr.fetchall()
# 		if len(res) == 0:
# 			cr.execute("""select id from res_partner where name ilike '%%%s'"""%(arg[2],arg[2])) 
# 			res = cr.fetchall()
# 		if len(res) == 0:
# 			cr.execute("""select id from res_partner where name ilike '%%%s%%'"""%(arg[2],arg[2])) 
# 			res = cr.fetchall()
# 		if len(res) == 0:
# 			return [('id', '=', 0)]
# 		return [('id', 'in', [x[0] for x in res])]
# 		
# 	_columns = {
# 		# 'name': fields.char('Name', size=64),
# 		# 'name': fields.function(_name_get_fnc, method=True,  type="char", size=256, string='Name', store=True,fnct_search=name_search),
# 		'name': fields.char('Name', size=128, required=True, select=True,fnct_search=name_search),
# 	}
# res_partner()

#--------------------------------------------------------------------------------------------------------
# ADD constraint to test invoing value for a line...
#--------------------------------------------------------------------------------------------------------
class account_analytic_line(osv.osv):
	_name = "account.analytic.line"
	# _description = "Analytic lines details"
	_inherit = "account.analytic.line"
	

	# If line is from timesheet => must contain invoice factor if account has got one
	def _check_account_to_invoice_value(self, cr, uid, ids):
		lines = self.browse(cr, uid, ids)
		for l in lines:
			if not l.to_invoice and l.account_id.to_invoice and 'Timesheet' in l.journal_id.name:
				return False
		return True
	_constraints = [
		(_check_account_to_invoice_value, 'Error ! You can not enter a null value for the invoice factor in this project.', ['account_id'])
	]
account_analytic_line()

#--------------------------------------------------------------------------------------------------------
# Invoicing line => must have analytic account
#--------------------------------------------------------------------------------------------------------
class account_invoice_line(osv.osv):
	_name = "account.invoice.line"
	_inherit = "account.invoice.line"
	_columns = {
		'account_analytic_id':  fields.many2one('account.analytic.account', 'Analytic Account', required=False),
	}
account_invoice_line()

#--------------------------------------------------------------------------------------------------------
# Invoice => Take the period of the invoice date and not current !
#--------------------------------------------------------------------------------------------------------
class account_invoice(osv.osv):
	_inherit="account.invoice"
	
	def onchange_payment_term_date_invoice(self, cr, uid, ids, payment_term_id, date_invoice):
		res={}
		if not date_invoice :
			date_invoice = self._defaults["date_invoice"](cr,uid,{})
		else:
			periods = self.pool.get('account.period').find(cr, uid,date_invoice)
			res= {'value':{'period_id':periods[0]}}
		
		if payment_term_id:
			pt_obj= self.pool.get('account.payment.term')
			pterm_list= pt_obj.compute(cr, uid, payment_term_id, value=1, date_ref=date_invoice)
			if pterm_list:
				pterm_list = [line[0] for line in pterm_list]
				pterm_list.sort()
				if 'value' in res.keys():
					res['value']['date_due']=pterm_list[-1]
				else:
					res= {'value':{'date_due':pterm_list[-1]}}
		return res
	
	_columns = {
		'date_due': fields.date('Due Date', states={'open':[('readonly',True)],'close':[('readonly',True)]},required=True ),
	}
account_invoice()
	
#--------------------------------------------------------------------------------------------------------
# size of name in payment term must be longer !
#--------------------------------------------------------------------------------------------------------
class account_payment_term(osv.osv):
	_name = "account.payment.term"
	_inherit = "account.payment.term"
	_columns = {
		'name': fields.char('Payment Term', size=64, translate=True),
	}
	
account_payment_term()
	
#######################################################################################
# Users add hr_departement
#######################################################################################
class users(osv.osv):
	_name = "res.users"
	_inherit = "res.users"
	
	_columns = {
		'departement_ids': fields.many2many('hr.department', 'hr_department_user_rel', 'user_id','department_id', 'Departement'),
	}

	def isadmin(self,user_id,cr):
		current_user = self.pool.get('res.users').read(cr, user_id, user_id)
		for gid in current_user['groups_id'] :
			group = self.pool.get('res.groups').read(cr, user_id, gid)
			if group['name'] == 'admin' :
				return True
		return False

	def isadminuser(self,user_id,cr):
		current_user = self.pool.get('res.users').read(cr, user_id, user_id)
		if current_user['login'] == 'admin' :
			return True
		return False
		
	def write(self, cr, uid, *args, **argv):
		isadmin = self.isadmin(uid,cr)
		isadminuser = self.isadminuser(uid,cr)
		#try to write user:
		user_idToWrite=args[0][0]
		for arg in args :
			if type(arg) is dict :
				if arg.has_key('groups_id'):
					gids =  arg['groups_id']
					gids = gids[0]
					for gid in gids[2] :
						group = self.pool.get('res.groups').read(cr, uid, gid)
						if group['name'] == 'admin'  and not isadmin :
							raise osv.except_osv('UserError', 'Only admin user can give admin rights')
				# Handel change of password admin
				if arg.has_key('password'):
					user_obj_towrite=self.pool.get('res.users').read(cr, uid, user_idToWrite)
					if user_obj_towrite['login']=='admin' and not isadminuser:
						raise osv.except_osv('UserError', 'Only admin user can change admin password')
			
		# Restart the cache on the company_get method
		res = super(users, self).write(cr, uid, *args, **argv)
		self.company_get()
		self.pool.get('ir.rule').domain_get()
		return res

users()

# #--------------------------------------------------------------------------------------------------------
# Pointage entré/sortie => Add user_id to allow filter on current user
#  Must enter in the current timesheet
#--------------------------------------------------------------------------------------------------------
class hr_attendance(osv.osv):
	_inherit = "hr.attendance"

	_columns = {
		'action' : fields.selection([('sign_in', 'Sign In'), ('sign_out', 'Sign Out')], 'Action', required=True),
		'user_id' : fields.many2one('res.users', 'User'),
	}
	_defaults = {
		'user_id': lambda obj, cr, uid, context: uid,
	}

	def create(self, cr, uid, vals, context={}):
		if 'sheet_id' in context:
			vals['sheet_id']=context['sheet_id']
		if 'sheet_id' in vals:
			ts = self.pool.get('hr_timesheet_sheet.sheet').browse(cr, uid, vals['sheet_id'])
			if ts.state not in ('draft', 'new'):
				raise osv.except_osv('Error !', 'You can not modify an entry in a confirmed timesheet !')
			# if not ((time.strptime (vals['name'].split()[0],"%Y-%m-%d") >= time.strptime(ts.date_from,"%Y-%m-%d")) and (time.strptime (vals['name'].split()[0],"%Y-%m-%d") <= time.strptime(ts.date_to,"%Y-%m-%d"))):
			if 'name' in vals:
				# Si c'est le wizard qui complete => c bon
				if 'origin' in context:
					if context['origin']<>'wizard_holiday':
						if not ((time.strptime (vals['name'].split()[0],"%Y-%m-%d") == time.strptime(ts.date_current,"%Y-%m-%d")) ):
							raise osv.except_osv('Error !', 'You can not enter an attendance date outside the current timesheet dates !')
		return super(hr_attendance,self).create(cr, uid, vals, context=context)

	def write(self, cr, uid, ids, vals, context={}):
		if 'sheet_id' in context:
			vals['sheet_id']=context['sheet_id']
		self._check(cr, uid, ids)
		for att in self.browse(cr, uid, ids):
			ts = att.sheet_id
			if ('name' in vals):
				# if not ((time.strptime (vals['name'].split()[0],"%Y-%m-%d") >= time.strptime(ts.date_from,"%Y-%m-%d")) and (time.strptime (vals['name'].split()[0],"%Y-%m-%d") <= time.strptime(ts.date_to,"%Y-%m-%d"))):
				if not ((time.strptime (vals['name'].split()[0],"%Y-%m-%d") == time.strptime(ts.date_current,"%Y-%m-%d")) ):
					raise osv.except_osv('Error !', 'You can not enter an attendance date outside the current timesheet dates !')
		return super(hr_attendance,self).write(cr, uid, ids, vals, context=context)

hr_attendance()


#----------------------------------------------------
# on change partner on res.partner.bank
#-----------------------------------------------------

class res_partner_bank(osv.osv):
	_inherit = 'res.partner.bank'
	def onchange_partner_id(self, cr, uid, ids, partner_id):
		if partner_id :
			add_ids = self.pool.get('res.partner').address_get(cr, uid, [partner_id], ['invoice','default'])
			add_id = add_ids['invoice'] or add_ids['default']		
			contact = self.pool.get('res.partner.address').browse(cr, uid, [add_id])[0]
			result = {'value': {	
				'street': contact.street,
				'city': contact.city,
				'zip': contact.zip,
				'country_id': contact.country_id.id}}
			result['value']['owner_name'] = self.pool.get('res.partner').browse(cr,uid, partner_id).name			
			return result
		
res_partner_bank()


#--------------------------------------------------
# on change partner on bank statement Line 
#--------------------------------------------------

#--------------------------------------------------
# a field function to compute the amount for an account move line 
#--------------------------------------------------

class account_bank_statement_line(osv.osv):
	_inherit = 'account.bank.statement.line'

	def onchange_partner_id(self, cursor, user, line_id, partner_id, type, currency_id,amount,
			context={}):
		
		if not partner_id:
			return {}
		res_currency_obj = self.pool.get('res.currency')
		res_users_obj = self.pool.get('res.users')

		company_currency_id = res_users_obj.browse(cursor, user, user,
				context=context).company_id.currency_id.id

		if not currency_id:
			currency_id = company_currency_id

		part = self.pool.get('res.partner').browse(cursor, user, partner_id,
				context=context)
		if type == 'supplier':
			account_id = part.property_account_payable.id
		else:
			account_id =  part.property_account_receivable.id
		if amount == 0:
			cursor.execute('SELECT sum(debit-credit) \
					FROM account_move_line \
					WHERE (reconcile_id is null) \
						AND partner_id = %d \
						AND account_id=%d', (partner_id, account_id))
			res = cursor.fetchone()
			balance = res and res[0] or 0.0
	
			balance = res_currency_obj.compute(cursor, user, company_currency_id,
					currency_id, balance, context=context)
			return {'value': {'amount': balance, 'account_id': account_id}}
		else:
			return {'value': {'account_id': account_id}}
			

account_bank_statement_line()

class account_move_line(osv.osv):
	_inherit = 'account.move.line'

	def _calc_amount_until_today(self, cr, uid, ids, name, arg, context={}):
		result = {}
		
		for account_line in self.browse(cr, uid, ids, context):
			num_cpt = str(account_line.account_id.id)
			start_year = str(account_line.period_id.fiscalyear_id.date_start)
			write_date = str(account_line.date)
			# We have the account ID we will search all account move line from now until this time
			cr.execute('SELECT (SUM(debit) - SUM(credit)) as tot_debit FROM account_move_line \
						WHERE account_id = ' + num_cpt + ' and date between \'' + start_year + '\' AND \'' + write_date + '\' ;'  
					)
			res = cr.dictfetchall()
			
			if len(res)>0:
				
				result[account_line.id] = res[0]['tot_debit'] 
		return result
	def _calc_contrepartie(self,cr,uid,ids, context={}):
		result = {}
			#for id in ids:
		#	result.setdefault(id, False)
		for account_line in self.browse(cr, uid, ids, context):
			# For avoid long text in the field we will limit it to 5 lines
			#
			#
			#
			result[account_line.id] = ' '
			num_id_move = str(account_line.move_id.id)
			num_id_line = str(account_line.id)
			account_id = str(account_line.account_id.id)
			# search the basic account 
			# We have the account ID we will search all account move line from now until this time
			# We are in the case of we are on the top of the account move Line
			cr.execute('SELECT distinct(ac.code) as code_rest,ac.name as name_rest from account_account AS ac, account_move_line mv\
				    where ac.id = mv.account_id and mv.move_id = ' + num_id_move +' and mv.account_id <> ' + account_id )
			res_mv = cr.dictfetchall()
			# we need a result more than 2 line to make the test so we will made the the on 1 because we have exclude the current line
			if (len(res_mv) >=1):
				concat = ''
				rup_id = 0
				for move_rest in res_mv:
					concat = concat + move_rest['code_rest'] + '|'
					result[account_line.id] = concat
					if rup_id >5:
						# we need to stop the computing and to escape but before we will add "..."
						result[account_line.id] = concat + '...'
						break
					rup_id+=1

		#print str(result)
		return result
	
	def _calc_line_corres(self, cr, uid, ids, name, arg, context={}):
		result = {}
		result =self._calc_contrepartie(cr,uid,ids)
		return result

	_columns = {
		'amount_line': fields.function(_calc_amount_until_today, method=True, type='float', string='Account balance'),
		'line_corresp' : fields.function(_calc_line_corres,method=True,type='char',string='Contrepartie'),
	}

account_move_line()

