# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2004-2006 TINY SPRL. (http://tiny.be) All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import time
from report import report_sxw
import xml
import rml_parse
import pooler
import copy
import re
from operator import itemgetter
#
# Repport for payment line
#
class crm_reporting_c2c(report_sxw.rml_parse):
	_name = 'report.crm.reportingc2c'
	gadr_cpt = 0

	def __init__(self, cr, uid, name, context):
		super(crm_reporting_c2c, self).__init__(cr, uid, name, context)
		user_obj=pooler.get_pool(cr.dbname).get('res.users')
		company=user_obj.browse(cr, uid, uid).company_id
		self.localcontext.update({
			'time': time,
			'company_name':company.name,
			'company_addr':company.partner_id.address[0].street,
			'company_addr2':company.partner_id.address[0].street2,
			'company_zip':company.partner_id.address[0].zip,
			'company_phone':company.partner_id.address[0].phone,
			'company_city':company.partner_id.address[0].city,
			'company_email':company.partner_id.address[0].email,
			'lines' : self.lines,
			'comma_me' : self.comma_me,
		})
		self.context = context
		
	def lines(self,crm_case_list={},form=[]):
		result_unsort = []
		#retour_unsort = self.get_result(ids)
		for crm_case_obj in crm_case_list:
			## We will now transform the obj in list mode
			print str(crm_case_obj)
			res = {
				'description': crm_case_obj.name,
				'contact_name' : (crm_case_obj.partner_address_id and crm_case_obj.partner_address_id.name or ' '),
				'partner_name' : (crm_case_obj.partner_id and crm_case_obj.partner_id.name or ' '),
				'date_created': crm_case_obj.create_date,
				'priority' : crm_case_obj.priority,
			}
			result_unsort.append(res)
		# We will now call the sort_unsort
		result_sorted = self.sort_result(result_unsort,form['sort_id'])
		return result_sorted
		#return retour_unsort
	
	def comma_me(self,amount):
		if  type(amount) is float :
			amount = str('%.2f'%amount)
		else :
			amount = str(amount)
		if (amount == '0'):
		     return ' '
		orig = amount
		new = re.sub("^(-?\d+)(\d{3})", "\g<1>'\g<2>", amount)
		if orig == new:
			return new
		else:
			return self.comma_me(new)

	def sort_result(self,list,sort_tag):
		if (sort_tag == 'priority'):
			result = sorted(list, key=itemgetter('priority'))
		elif (sort_tag == 'partner'):
			result = sorted(list, key=itemgetter('partner_name'))
		elif (sort_tag == 'date'):
			result = sorted(list, key=itemgetter('date_created'))
		else:
			result = sorted(list, key=itemgetter('description'))
			
		return result
	

report_sxw.report_sxw('report.crm.reportingc2c', 'crm.case','addons/c2c_crm_reporting/crm_reporting.rml', parser=crm_reporting_c2c, header=False)


