# -*- coding: utf-8 -*- 
##############################################################################
#
# Copyright (c) 2008 Camptocamp SA
# @author JB Aubort
# $Id$
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import wizard
import pooler
import pprint

class wizard_currency_rate_update(wizard.interface):
    _init_arch =  '''<?xml version="1.0"?>
    <form string="Update Now">
        <label string="Update exchange rates now ?" colspan="4"/>
    </form>'''

    _update_arch = '''<?xml version="1.0"?>
    <form string="Update Now">
        <label string="Updated !" colspan="4"/>
    </form>'''

    _empty_fields = {}

    _update_fields = {
        'updated': {'string':'Updated', 'type':'char', 'size':20, 'readonly':True},
    }

    def _update(self, cr, uid, data, context):
        self.pool = pooler.get_pool(cr.dbname)
        rate_search = self.pool.get('currency.rate.update').search(cr, uid, [('id','=',data['id'])])
        if len(rate_search)>0:
            rate_id = rate_search[0]
            update_rate_obj = self.pool.get('currency.rate.update')
            updated = update_rate_obj.update(cr, uid, rate_id)
        return {}

    states = {
        'init': {
            'actions': [],
            'result': {'type': 'form', 'arch':_init_arch, 'fields':_empty_fields, 'state': [('end', 'Cancel'), ('update', 'Update Now')]}
        },
        'update': {
        	'actions': [_update],
        	'result': {'type': 'form', 'arch':_update_arch, 'fields':_update_fields, 'state':[('end', 'Close')]}
        }
    }
wizard_currency_rate_update('currency.rate.update')
