from c2c_reporting_tools.reports.standard_report import StandardReport
from c2c_reporting_tools.flowables.simple_row_table import *

from reportlab.platypus import Paragraph
from reportlab.lib.styles import ParagraphStyle


from c2c_reporting_tools.translation import _
from c2c_reporting_tools.flowables.timebox_chart import  *
from datetime import datetime
from  time import gmtime
import pooler
import pdb

class open_sale_report(StandardReport):     
    def __init__(self, openerp_name, title="", objects_name=None, template_name=None):
        """ DO NOT USE title PARAM anymore. Overload get_template_title() instead """
        
        self.template_name = template_name        
        #self.template_title = title
        self.report_title = 'TR'
        super(StandardReport, self).__init__(openerp_name, objects_name)

    def get_row_data(self,cr,user,startdate,company_id,account_type):
        ##
        cr.execute("SELECT line.* " \
                "FROM account_move_line AS line, account_account " \
                "WHERE (line.account_id = account_account.id) " \
                    "AND (account_account.type IN " + account_type + ") " \
                    " AND line.origin_link IS NULL " \
                    "AND ((line.reconcile_id IS NULL) " \
                        "OR (line.reconcile_id IN (SELECT line2.reconcile_id from account_move_line as line2 WHERE line2.date > %s ))) " \
                    "AND line.partner_id IS NOT NULL " \
                    "AND line.date <= %s  " \
                    "AND (account_account.company_id = %d) " ,
                    (startdate,startdate, company_id))
        result_selection = self.cr.dictfetchall()
        return result_selection
    
    def get_row_partner_data(self,cr,user,startdate,company_id,account_type):
        ##
        cr.execute("SELECT distinct(line.partner_id) as partner_id,partner.name " \
                "FROM account_move_line AS line, account_account,res_partner as partner " \
                "WHERE (line.account_id = account_account.id) " \
                    "AND (account_account.type IN " + account_type + ") " \
                    " AND line.origin_link IS NULL " \
                    "AND ((line.reconcile_id IS NULL) " \
                        "OR (line.reconcile_id IN (SELECT line2.reconcile_id from account_move_line as line2 WHERE line2.date > %s ))) " \
                    "AND line.partner_id IS NOT NULL " \
                    "AND line.partner_id = partner.id " \
                    "AND line.date <= %s  " \
                    "AND (account_account.company_id = %d) " \
                    "ORDER by partner.name " ,
                    (startdate,startdate, company_id))
        result_selection = self.cr.dictfetchall()
        return result_selection

    def _filtre_partner_in(self,dict_elem):
        
        if dict_elem['partner_id'] == self.current_partner_id:
            return dict_elem

    def _filtre_by_partner_and_date(self,dict_elem):
  
        if (((dict_elem['date_maturity'] or dict_elem['date']) >= self.current_from_date) and ((dict_elem['date_maturity'] or dict_elem['date']) <= self.current_to_date)) :
            #import pdb
            #pdb.set_trace()
            return dict_elem

    def _filtre_by_partner_and_before_date(self,dict_elem):
  
        if ((dict_elem['date_maturity'] or dict_elem['date']) <= self.start_date) :
            return dict_elem

    def _filtre_by_partner_and_after_date(self,dict_elem):
  
        if ((dict_elem['date_maturity'] or dict_elem['date']) >= self.start_date) :
            return dict_elem


    def _sum_function(self,x,y):
       
        result =x + (y['debit'] - y['credit'])
        return result
        


    def get_template_title(self, cr, context):
        if (self.datas['form']['result_selection'] == 'customer' ):
            self.report_title = 'Aged partner Balance / Customer'
        elif (self.datas['form']['result_selection'] == 'supplier'):
            self.report_title = _('Aged partner Balance / Supplier')
        else:
            self.report_title = _('Aged partner Balance / All ')
        if self.datas['form']['direction_selection'] == 'future':
            self.report_title = self.report_title + _('/ Open amount')
        else:
            self.report_title = self.report_title + _('/ Due amount')
            
        return self.report_title

 

    def get_story(self):
        story = []
        pool = pooler.get_pool(self.cr.dbname)
        #
        # timebox chart demo
        #
        ## Get maximum and minimum date
        ## We will contruct 
        if (self.datas['form']['result_selection'] == 'customer' ):
            self.ACCOUNT_TYPE = "('receivable')"
        elif (self.datas['form']['result_selection'] == 'supplier'):
            self.ACCOUNT_TYPE = "('payable')"
        else:
            self.ACCOUNT_TYPE = "('payable','receivable')"

        all_unfiltred_result = self.get_row_data(self.cr,self.uid,self.datas['form']['date1'],self.datas['form']['company_id'],self.ACCOUNT_TYPE)
        all_concerned_partner = self.get_row_partner_data(self.cr,self.uid,self.datas['form']['date1'],self.datas['form']['company_id'],self.ACCOUNT_TYPE)
        F1_part = self.datas['form']['0']['name']
        F2_part = self.datas['form']['1']['name']
        F3_part = self.datas['form']['2']['name']
        F4_part = self.datas['form']['3']['name']
        F5_part = self.datas['form']['4']['name']
        ##
        self.start_date = self.datas['form']['date1']
        if self.datas['form']['direction_selection'] == 'future':
            label_champs = _('Due amount ') + str(self.datas['form']['date1'])
            label_champs_total = _('Total open amount ') 
            before_result = filter(self._filtre_by_partner_and_before_date,all_unfiltred_result)
            ## Reset value
            self.start_date = self.datas['form']['0']['start']
            first_result = filter(self._filtre_by_partner_and_after_date,all_unfiltred_result)
        else:
            label_champs = _('Open amount ') + str(self.datas['form']['date1'])
            label_champs_total = _('Total due amount ') 
            before_result = filter(self._filtre_by_partner_and_after_date,all_unfiltred_result)
            #
            self.start_date = self.datas['form']['0']['stop']
            first_result = filter(self._filtre_by_partner_and_before_date,all_unfiltred_result)
            
        ### Create different search table
        #self.current_from_date = self.datas['form']['0']['start']
        #self.current_to_date = self.datas['form']['0']['stop']
        #first_result = filter(self._filtre_by_partner_and_date,all_unfiltred_result)
        ## Second result tab
        self.current_from_date = self.datas['form']['1']['start']
        self.current_to_date = self.datas['form']['1']['stop']
        second_result = filter(self._filtre_by_partner_and_date,all_unfiltred_result)
        ## thirs result tab
        self.current_from_date = self.datas['form']['2']['start']
        self.current_to_date = self.datas['form']['2']['stop']
        third_result = filter(self._filtre_by_partner_and_date,all_unfiltred_result)
        ## fourth result tab
        self.current_from_date = self.datas['form']['3']['start']
        self.current_to_date = self.datas['form']['3']['stop']
        fourth_result = filter(self._filtre_by_partner_and_date,all_unfiltred_result)
        ## fifth result tab
        self.current_from_date = self.datas['form']['4']['start']
        self.current_to_date = self.datas['form']['4']['stop']
        fifth_result = filter(self._filtre_by_partner_and_date,all_unfiltred_result)
       
        
        ## Create a new table
        builder = C2cStyleRowsTable('')
                
        ## Set informations about period
        #columns
        # Unit of Mesure Label
        unit_mesure = _('Days')
        builder.add_text_column(_('Partners'),"25%")
        builder.add_num_column(F5_part + ' ' + unit_mesure)
        builder.add_num_column(F4_part + ' ' + unit_mesure)
        builder.add_num_column(F3_part + ' ' + unit_mesure)
        builder.add_num_column(F2_part + ' ' + unit_mesure)
        builder.add_num_column(F1_part + ' ' + unit_mesure)
        builder.add_num_column(label_champs_total)
        builder.add_num_column(label_champs)
        builder.add_num_column(_('Total'))
        
        for id_partner in all_concerned_partner:
            ## Init current parner global variable
            self.current_partner_id = id_partner['partner_id']
            name_partner = id_partner['name']
                ## We now now that we have this partner in result
                # first part of search
                ## On ajoute
            if before_result:
                partner_in_result_tab = filter(self._filtre_partner_in,before_result)
                tot_for_before_result = reduce(self._sum_function, partner_in_result_tab,0)
            else:
                tot_for_before_result = 0.0
            ### DEBUG
            
            if first_result:
                partner_in_result_tab = filter(self._filtre_partner_in,first_result)
                tot_for_first_result = reduce(self._sum_function, partner_in_result_tab,0)
            else:
                tot_for_first_result = 0.0
            if second_result:
                partner_in_result_tab = filter(self._filtre_partner_in,second_result)
                tot_for_second_result = reduce(self._sum_function, partner_in_result_tab,0)
            else:
                tot_for_second_result = 0.0 
            if third_result:
                partner_in_result_tab = filter(self._filtre_partner_in,third_result)
                tot_for_third_result = reduce(self._sum_function, partner_in_result_tab,0)
            else:
                tot_for_third_result = 0.0
            
            if fourth_result:
                partner_in_result_tab = filter(self._filtre_partner_in,fourth_result)
                tot_for_fourth_result = reduce(self._sum_function, partner_in_result_tab,0)
            else:
                tot_for_fourth_result = 0.0
            if fifth_result:
                partner_in_result_tab = filter(self._filtre_partner_in,fifth_result)
                tot_for_fifth_result = reduce(self._sum_function, partner_in_result_tab,0)
            else:
                tot_for_fifth_result = 0.0
                
            ## so we send result
            builder.add_text_cell(name_partner)
            builder.add_num_cell(tot_for_fifth_result)
            builder.add_num_cell(tot_for_fourth_result)
            builder.add_num_cell(tot_for_third_result)
            builder.add_num_cell(tot_for_second_result)
            builder.add_num_cell(tot_for_first_result)
            builder.add_num_cell(tot_for_first_result + tot_for_second_result + tot_for_third_result + tot_for_fourth_result + tot_for_fifth_result )
            builder.add_num_cell(tot_for_before_result)
            builder.add_num_cell(tot_for_before_result + tot_for_first_result + tot_for_second_result + tot_for_third_result + tot_for_fourth_result + tot_for_fifth_result)
        
        ##
        cell_test = TextCellData(_('Total'))
        cell_test.font='Helvetica-bold'
        builder.add_custom_cell(cell_test)
        builder.add_subtotal_num_cell()
        builder.add_subtotal_num_cell()
        builder.add_subtotal_num_cell()
        builder.add_subtotal_num_cell()
        builder.add_subtotal_num_cell()
        builder.add_subtotal_num_cell()
        builder.add_subtotal_num_cell()
        builder.add_subtotal_num_cell()
        
        ## Add the invoice line table, we put at this place bescause we want to have the resume to be display first
        story.append(builder.get_table())
        #
        # We will now get standard informations for this user
        #
        return story
    
    
    
open_sale_report('report.advanced.trial.balancec2c', 'Aged partner balance','res.partner', StandardReport.A4_LANDSCAPE)        