from c2c_reporting_tools.reports.standard_report import StandardReport
from c2c_reporting_tools.flowables.simple_row_table import *

from reportlab.platypus import Paragraph
from reportlab.lib.styles import ParagraphStyle


from c2c_reporting_tools.translation import _
from c2c_reporting_tools.flowables.timebox_chart import  *
from c2c_reporting_tools.templates.standard_template import *

from datetime import datetime
from  time import gmtime
import pooler
import pdb

class c2c_general_ledger(StandardReport):     
    def __init__(self, openerp_name, title="", objects_name=None, template_name=None):
        """ DO NOT USE title PARAM anymore. Overload get_template_title() instead """
            
        #self.template_name = template_name        
        #self.template_title = title
        self.report_title = 'TR'

        super(StandardReport, self).__init__(openerp_name, objects_name)

    def _get_current_fiscal_year_for_date(self,cr,user,date_select):
        cr.execute("select id as fiscalyear_id from account_fiscalyear where '" + str(date_select) + "' BETWEEN date_start AND date_stop" )
        result_selection = self.cr.dictfetchall()
        return result_selection[0]


    # This function is designed to get the date start of the 
    def _get_start_date_fiscal_year_for_date(self,cr,user,date_select):
        cr.execute("select date_start from account_fiscalyear where  date_start < '" + str(date_select) + "' AND state <> 'done' AND company_id = " + str(self.datas['form']['company_id']) + " " )
        result_selection = self.cr.dictfetchall()
        return result_selection[0]

    ## This function returne all period before the period selection that are in draft mode
    def _get_period_all_period_fiscal_year(self,cr,user):
        ## Transalate the data_receive into a map
        periods_id = self.datas['form']['periods'][0][2]
        periods_ids_map = ','.join(map(str,periods_id))
        ## Get maximum period_id in selection
        #
        cr.execute("select period.id as id from account_period as period where period.date_stop <= (select max(period2.date_stop) from account_period as period2 where period2.id in ("+ periods_ids_map +")) and state <> 'done' ")
        result_id = self.cr.dictfetchall()
        result_tab = []
        if result_id:
            # We have open period before the selected period
            for result in result_id:
                result_tab.append(result['id'])
        return result_tab

    ## This function returns All period that are prevous the greatest selected period and that are in safe mode 
    def _get_period_previous_period_fiscal_year(self,cr,user):
        ## Transalate the data_receive into a map
        periods_id = self.datas['form']['periods'][0][2]
        periods_ids_map = ','.join(map(str,periods_id))
        ## Get maximum period_id in selection
        #
        cr.execute("select period.id as id from account_period as period where period.date_stop < (select min(period2.date_start) from account_period as period2 where period2.id in ("+ periods_ids_map +")) and state <> 'done' ")
        result_id = self.cr.dictfetchall()
        result_tab = []
        if result_id:
            # We have open period before the selected period
            for result in result_id:
                result_tab.append(result['id'])
        return result_tab


    # get all lines for this the select periods
    def get_row_data_line_by_period(self,cr,user,company_id,period_list):
        ##
        period_map = ','.join(map(str,period_list))
        cr.execute("SELECT line.*,partner.name as part_name,mvt.name as mvt_name " \
                "FROM account_move_line AS line "\
                " LEFT JOIN  res_partner as partner ON partner.id = line.partner_id " \
                " JOIN account_account as account ON line.account_id = account.id" \
                " JOIN account_move as mvt ON line.move_id = mvt.id" \
                " WHERE " \
                    " line.period_id IN (" + period_map + ") AND line.account_id = account.id " \
                    " AND (account.company_id = %d) " ,
                    (company_id,))
        result_selection = self.cr.dictfetchall()
        
        return result_selection

    # get all lines form selection dates
    def get_row_data_line_by_date(self,cr,user,company_id,min_date,max_date):
        ##
        cr.execute("SELECT line.*,partner.name as part_name,mvt.name as mvt_name " \
                "FROM account_move_line AS line "\
                " LEFT JOIN  res_partner as partner ON partner.id = line.partner_id " \
                " JOIN account_account as account ON line.account_id = account.id" \
                " JOIN account_move as mvt ON line.move_id = mvt.id" \
                " WHERE " \
                    " line.date <= %s  AND line.date >= %s " \
                    " AND (account.company_id = %d)" ,
                    (max_date,min_date,company_id))
        result_selection = self.cr.dictfetchall()
        #import pdb
        #pdb.set_trace()h
        return result_selection

    # Filter for initial accounting
    def _filtre_account_solde_init(self,dict_elem):
        
        
        if self.datas['form'].has_key('fiscalyear'):
            ## We are in a fiscal year content
            if (dict_elem['account_id'] == self.account_id and dict_elem['period_id'] in self.unclosed_previous_period_list):
                return dict_elem
        else:
            #import pdb
            #pdb.set_trace()
            date_fiscal_year_start = self.min_date_draft_fiscal_year_for_date_range
            
            if (dict_elem['account_id'] == self.account_id) and (dict_elem['date'] >= date_fiscal_year_start['date_start'] and dict_elem['date'] < self.datas['form']['date_from'] ):
                return dict_elem

    # 
    def _filtre_account_only(self,dict_elem):
            if dict_elem['account_id'] == self.account_id :
                return dict_elem



    def _filtre_account_in(self,dict_elem):
        
        if self.datas['form'].has_key('fiscalyear'):
            ## We are in a fiscal year content
            
            if (dict_elem['account_id'] == self.account_id and dict_elem['period_id'] in self.datas['form']['periods'][0][2]):
                return dict_elem
        else:
            #import pdb
            #pdb.set_trace()
            if (dict_elem['account_id'] == self.account_id) and (dict_elem['date'] >= self.datas['form']['date_from'] and dict_elem['date'] <= self.datas['form']['date_to'] ):
                return dict_elem


    def _sum_function_debit(self,x,y):
        result =x + y['debit']
        return result

    def _sum_function_credit(self,x,y):
        result =x + y['credit']
        return result

    def _sum_function_balance(self,x,y):
        result =x + (y['debit'] - y['credit'])
        return result


    def _sum_function_amount_currency(self,x,y):
        result =x + (y['amount_currency'] or 0.0)
        return result

    
    def _sort_by_date(self,x,y):
        if (x['date'] > y['date']):
            return 1
        elif (x['date'] == y['date']):
            return 0
        else:
            return -1

    def _sort_by_mvt(self,x,y):
        if (x['mvt_name'] > y['mvt_name']):
            return 1
        elif (x['mvt_name'] == y['mvt_name']):
            return 0
        else:
            return -1
    

    def _sum_function_credit(self,x,y):
        result =x + y['credit']
        return result

    def get_account_child(self,ids={},done=None,level=1):
        if not ids:
            ids = self.ids
        if not ids:
            return []
        if not done:
            done={}
        result = []
        accounts = self.pool.get('account.account').browse(self.cr, self.uid, ids,self.context)
        def cmp_code(x, y):
            return cmp(x.code, y.code)
        accounts.sort(cmp_code)
        for account in accounts:
            if account.id in done:
                continue
            done[account.id] = 1
            result.append(account.id)
            if account.child_id:
                ids2 = [(x.code,x.id) for x in account.child_id]
                ids2.sort()
                result += self.get_account_child([x[1] for x in ids2], done,level+1)
        return result


    def get_template_title(self, cr, context):
      if (self.datas['form']['display_account'] == 'bal_all' ):
            self.report_title = _('General Ledger / All')
      elif (self.datas['form']['display_account'] == 'bal_solde'):
            self.report_title = _('General Ledger / With balance is not equal to 0')
      else: 
            self.report_title = _('General Ledger / With movements')
            
      return self.report_title
 

    def get_template(self, cr, context):
        """ define the template of the report """

        # choose the appropriate template
        if self.datas['form']['landscape']:
            doc = STLandscape()
        else:
            doc = STPortrait()

        user = self.pool.get('res.users').browse(self.cr,self.uid,self.uid, self.context)        
        doc.company_name = user.company_id.name
            
            
        doc.report_name = self.get_template_title(cr, context)
        
        return doc


    def _calc_contrepartie(self,cr,uid,ids, context={}):
        result = ''
            #for id in ids:
        #   result.setdefault(id, False)
        
        for account_line in self.pool.get('account.move.line').browse(cr, uid,ids, context):
            # For avoid long text in the field we will limit it to 5 lines
            #
            #
            #
            num_id_move = str(account_line.move_id.id)
            num_id_line = str(account_line.id)
            account_id = str(account_line.account_id.id)
            # search the basic account 
            # We have the account ID we will search all account move line from now until this time
            # We are in the case of we are on the top of the account move Line
            cr.execute('SELECT distinct(ac.code) as code_rest,ac.name as name_rest from account_account AS ac, account_move_line mv\
                    where ac.id = mv.account_id and mv.move_id = ' + num_id_move +' and mv.account_id <> ' + account_id )
            res_mv = cr.dictfetchall()
            # we need a result more than 2 line to make the test so we will made the the on 1 because we have exclude the current line
            if (len(res_mv) >=1):
                concat = ''
                rup_id = 0
                for move_rest in res_mv:
                    concat = concat + move_rest['code_rest'] + '|'
                    result = concat
                    if rup_id >5:
                        # we need to stop the computing and to escape but before we will add "..."
                        result = concat + '...'
                        break
                    rup_id+=1

        #print str(result)
        return result

    def get_story(self):
        
        
        ## Define table Model
        
        
        story = []
        pool = pooler.get_pool(self.cr.dbname)
        if self.datas['form'].has_key('fiscalyear'):
            ## Variable to store previous unclosed period
            if not self.datas['form']['periods'][0][2] :
                self.datas['form']['periods'][0][2] =  self.pool.get('account.period').search(self.cr, self.uid, [('fiscalyear_id','=',self.datas['form']['fiscalyear'])])
            self.all_previous_period_before_range = self._get_period_all_period_fiscal_year(self.cr,self.uid)
        #import pdb
        #pdb.set_trace()
        if self.datas['form'].has_key('fiscalyear'):
            ## We are in a fiscal year content
                # Store previous unclosed period
                ## Get previuos 
                self.unclosed_previous_period_list = self._get_period_previous_period_fiscal_year(self.cr,self.uid)
                raw_result = self.get_row_data_line_by_period(self.cr,self.uid,self.datas['form']['company_id'],self.all_previous_period_before_range)
        else:
            ## We are in a date content
                ## Get the minimal date for compute solde initial in case of request
                self.min_date_draft_fiscal_year_for_date_range = self._get_start_date_fiscal_year_for_date(self.cr,self.uid,self.datas['form']['date_to'])
                raw_result = self.get_row_data_line_by_date(self.cr,self.uid,self.datas['form']['company_id'],self.min_date_draft_fiscal_year_for_date_range['date_start'],self.datas['form']['date_to'])
                
                
        ## We will now make sort on
        if self.datas['form']['sortbydate'] == 'sort_date':
            raw_result.sort(self._sort_by_date)
        else:
            raw_result.sort(self._sort_by_mvt)
            
        ##
        ## Get child account
        new_ids = []
        if (self.datas['model'] == 'account.account'):
            new_ids = self.ids
        else:
            new_ids.append(self.datas['form']['Account_list'])
            
        account_list =  self.get_account_child(new_ids)
        
        ###
        for account_id in account_list:
            ##
            
            ##
            ## Create a new table
            self.account_id = account_id
            full_result = filter(self._filtre_account_only,raw_result)
            account_in_result_tab = filter(self._filtre_account_in,full_result)
            ## We will make the sum
            sum_credit = reduce(self._sum_function_credit, account_in_result_tab,0)
            sum_debit = reduce(self._sum_function_debit, account_in_result_tab,0)
            sum_balance = reduce(self._sum_function_balance, account_in_result_tab,0)
            do_not_print = False
            ## We will make test on impression TEST
            if self.datas['form']['display_account'] == 'bal_mouvement':
                if len(account_in_result_tab) == 0:
                    do_not_print = True
            elif self.datas['form']['display_account'] == 'bal_all':
                do_not_print = False
            else:
                if sum_balance == 0:
                    do_not_print = True
            
            if do_not_print == False:
                ## Get account information
                current_account = self.pool.get('account.account').browse(self.cr, self.uid, account_id)
                builder = C2cStyleRowsTable(current_account.code + ' - ' + current_account.name)
                        
                ## Set informations about period
                #columns
                cumul_balance = 0.0
                cumul_currency = 0.0
                if self.datas['form']['landscape']:
                    builder.add_date_column(_('Date'),width='60', format="%d.%m.%Y")
                    builder.add_text_column(_('MVT'),width='30')
                    builder.add_text_column(_('Partner'),width='100')
                    builder.add_text_column(_('Ref.'),width='80')
                    builder.add_text_column(_('Entry Label'))
                    builder.add_text_column(_('Counterpart'),width='80')
                    builder.add_num_column(_('Debit'),width='60')
                    builder.add_num_column(_('Credit'),width='60')
                    builder.add_num_column(_('Balance'),width='60')
                else:
                    builder.add_date_column(_('Date'),width='60', format="%d.%m.%Y")
                    builder.add_text_column(_('MVT'),width='30')
                    builder.add_text_column(_('Partner'))
                    builder.add_text_column(_('Entry Label'))
                    builder.add_num_column(_('Amount'),width='50')
                    builder.add_num_column(_('Balance'),width='50')
                if self.datas['form']['amount_currency']:
                    builder.add_money_column(_('Amount Currency'),width='80')
                    builder.add_money_column(_('Currency Balance'),width='80')

                ## Compute Solde init in case of user request
                if self.datas['form']['soldeinit']:
                    #import pdb
                    #pdb.set_trace()
                    #
                    all_init_line = filter(self._filtre_account_solde_init,full_result)
                    if all_init_line:
                        init_credit = reduce(self._sum_function_credit, all_init_line,0)
                        init_debit = reduce(self._sum_function_debit, all_init_line,0)
                        init_balance = reduce(self._sum_function_balance, all_init_line,0)
                        ##
                        cumul_balance = init_balance
                        ##
                        init_currency = reduce(self._sum_function_amount_currency, all_init_line,0)
                        cumul_currency = init_currency

                        builder.add_date_cell(None)
                        builder.add_text_cell(_('Total'))
                        builder.add_text_cell('')
                        builder.add_text_cell('')
                        if self.datas['form']['landscape']:
                            builder.add_text_cell('')
                            builder.add_text_cell('')
                        if self.datas['form']['landscape']:
                            builder.add_num_cell(init_debit or 0.0)
                            builder.add_num_cell(init_credit or 0.0)
                        else:
                            builder.add_num_cell(init_debit - init_credit or 0.0)
                        builder.add_num_cell(init_balance)
                        if self.datas['form']['amount_currency']:
                            builder.add_money_cell(0.0)
                            if current_account.currency_id:
                                currency_money = self.pool.get('res.currency').browse(self.cr, self.uid,[current_account.currency_id.id])
                                if currency_money:
                                        currency_code = currency_money[0].code
                                else:
                                    currency_code = ''
    
                                builder.add_money_cell(init_currency,currency=currency_code)
                            else:
                                builder.add_money_cell(0.0)
                        
                        
                for line in account_in_result_tab:   
                    builder.add_date_cell(line['date'])
                    ## so we send result
                    invoice_ids = self.pool.get('account.invoice').search(self.cr, self.uid, [('move_id','=',line['move_id'])])
                    invoice_obj = self.pool.get('account.invoice').browse(self.cr, self.uid,invoice_ids)
                    if invoice_obj:
                        ref = (invoice_obj[0].number or line['ref'] or '/')
                    else:
                        ref = (line['ref'] or '/')
                    #
                    ##
                    builder.add_text_cell(line['mvt_name'])
                    builder.add_text_cell(line['part_name'])
                    if self.datas['form']['landscape']:
                        builder.add_text_cell(c2c_helper.ellipsis(ref,19,'[...]'))
                    builder.add_text_cell(line['name'])
                    if self.datas['form']['landscape']:
                        builder.add_text_cell(c2c_helper.ellipsis(self._calc_contrepartie(self.cr,self.uid,[line['id']]),15,'[...]'))
                    if self.datas['form']['landscape']:
                        builder.add_num_cell(line['debit'] or 0.0)
                        builder.add_num_cell(line['credit'] or 0.0)
                    else:
                        builder.add_num_cell(line['debit'] - line['credit'] or 0.0)
                    cumul_balance += (line['debit'] - line['credit'])
                    cumul_currency += line['amount_currency'] or 0.0
                    builder.add_num_cell(cumul_balance)
                    if self.datas['form']['amount_currency']:
                        if line['amount_currency']:
                            if line['currency_id']:
                                currency_money = self.pool.get('res.currency').browse(self.cr, self.uid,[line['currency_id']])
                                if currency_money:
                                    currency_code = currency_money[0].code
                            else:
                                currency_code = ''
                            builder.add_money_cell(line['amount_currency'] or 0.0,currency=currency_code)
                        else:   
                            builder.add_money_cell(line['amount_currency'] or 0.0)
                        ## We test if the account have an second currency
                        if current_account.currency_id:
                            builder.add_money_cell(cumul_currency or 0.0,currency=current_account.currency_id.code)
                        else:
                            builder.add_money_cell(0.0)
                        
                        
                    
                builder.add_date_cell(None)
                builder.add_text_cell('')
                builder.add_text_cell('')
                if self.datas['form']['landscape']:
                    builder.add_text_cell('')
                    builder.add_text_cell('')
                builder.add_text_cell(_('Total'))
                if self.datas['form']['landscape']:
                    builder.add_subtotal_num_cell()
                    builder.add_subtotal_num_cell()
                else:
                    builder.add_subtotal_num_cell()
                    
                #
                cell_test = NumCellData(cumul_balance)
                cell_test.font='Helvetica-bold'
                builder.add_custom_cell(cell_test)
                if self.datas['form']['amount_currency']:
                    builder.add_money_cell(0.0)
                    if current_account.currency_id:
                        cell_test = MoneyCellData(cumul_currency,currency=current_account.currency_id.code)
                    else:
                        cell_test = MoneyCellData(0.0)
                    builder.add_custom_cell(cell_test)
        
        ## Add the invoice line table, we put at this place bescause we want to have the resume to be display first
                story.append(Spacer(10,10))
                story.append(builder.get_table())
                ## if the table is more than one and the we nee splitbypartner
        #
        # We will now get standard informations for this user
        #
        
        return story
    
    
    
c2c_general_ledger('report.advanced.general.ledgerc2c', 'General Ledger','res.partner')        