from c2c_reporting_tools.reports.standard_report import StandardReport
from c2c_reporting_tools.flowables.simple_row_table import *

from reportlab.platypus import Paragraph
from reportlab.lib.styles import ParagraphStyle


from c2c_reporting_tools.translation import _
from c2c_reporting_tools.flowables.timebox_chart import  *
from datetime import datetime
from  time import gmtime
import pooler
import pdb

class c2c_third_party_ledger(StandardReport):     
    def __init__(self, openerp_name, title="", objects_name=None, template_name=None):
        """ DO NOT USE title PARAM anymore. Overload get_template_title() instead """
        
        self.template_name = template_name        
        #self.template_title = title
        self.report_title = 'TR'

        super(StandardReport, self).__init__(openerp_name, objects_name)

    def _get_min_date_unclosed_fiscal_year(self,cr,user):
        cr.execute("select min(date_start) as date_open_fiscal_year_min from account_fiscalyear where state<>'done'")
        result_selection = self.cr.dictfetchall()
        return result_selection[0]

    def _get_period_all_period_fiscal_year(self,cr,user):
        ## Transalate the data_receive into a map
        periods_id = self.datas['form']['periods'][0][2]
        periods_ids_map = ','.join(map(str,periods_id))
        
        cr.execute("select period.id from account_period as period where period.date_stop <= (select max(period2.date_stop) from account_period  as period2 where period2.id IN ("+ periods_ids_map +"));")
  
        result_id = self.cr.dictfetchall()
        result_tab = []
        if result_id:
            # We have open period before the selected period
            for result in result_id:
                result_tab.append(result['id'])
        return result_tab

    def _get_all_futur_period_fiscal_year(self,cr,user):
        ## Transalate the data_receive into a map
        periods_id = self.datas['form']['periods'][0][2]
        periods_ids_map = ','.join(map(str,periods_id))
        
        cr.execute("select period.id from account_period as period  where period.date_start >= (select max(period2.date_stop)  from account_period  as period2 where period2.id IN ("+ periods_ids_map +")) and period.company_id = 2;")
        result_id = self.cr.dictfetchall()
        result_tab = []
        if result_id:
            # We have open period before the selected period
            for result in result_id:
                result_tab.append(result['id'])
        return result_tab




    def _get_period_unclosed_fiscal_year(self,cr,user):
        ## Transalate the data_receive into a map
        periods_id = self.datas['form']['periods'][0][2]
        periods_ids_map = ','.join(map(str,periods_id))
        
        cr.execute("select period.id from account_period as period where period.date_stop < (select min(period2.date_start) from account_period  as period2 where period2.id IN ("+ periods_ids_map + "));")
        result_id = self.cr.dictfetchall()
        result_tab = []
        if result_id:
            # We have open period before the selected period
            for result in result_id:
                result_tab.append(result['id'])
        return result_tab
    
    def get_row_data_period_without_reconcile_line(self,cr,user,company_id,account_type):
        ## Transalate the data_receive into a map
        periods_id = self.datas['form']['periods'][0][2]
        periods_ids_map = ','.join(map(str,periods_id))
        ##
        futur_period_id = ','.join(map(str,self._get_all_futur_period_fiscal_year(cr,user)))
        unclosed_period_id = ','.join(map(str,self._get_period_all_period_fiscal_year(cr,user))) 
        if futur_period_id :
            reconcile_test = "AND ((line.reconcile_id IS NULL) OR (line.reconcile_id IN (SELECT line2.reconcile_id from account_move_line as line2 where line2.period_id  IN ("+ futur_period_id +") )))" 
        else:
            reconcile_test = "AND (line.reconcile_id IS NULL) " 
                

        ## In this request we have a 
        cr.execute("SELECT line.* " \
                "FROM account_move_line AS line, account_account " \
                "WHERE (line.account_id = account_account.id) " \
                    "AND (account_account.type IN " + account_type + ") " \
                    " " + reconcile_test + " "
                    "AND line.partner_id IS NOT NULL " \
                    "AND ((line.period_id IN ("+ unclosed_period_id + ") and line.origin_link IS NULL)" \
                        "or (line.id in (select line3.origin_link from account_move_line as line3 where line3.origin_link IS NOT NULL AND line3.period_id IN ("+ unclosed_period_id +")  ))) "
                    "AND (account_account.company_id = %d) ORDER BY line.date" ,
                    (company_id,))
        
        result_selection = self.cr.dictfetchall()
        print len(result_selection)
        return result_selection


    def get_row_data_period_reconcile_line(self,cr,user,company_id,account_type):
        ##
        unclosed_period_id = ','.join(map(str,self._get_period_all_period_fiscal_year(cr,user)))
        ## if unclosed period_id is null we will use 
        cr.execute("SELECT line.* " \
                "FROM account_move_line AS line, account_account " \
                "WHERE (line.account_id = account_account.id) " \
                    "AND (account_account.type IN " + account_type + ") " \
                    "AND line.partner_id IS NOT NULL " \
                    #" AND line.origin_link IS NULL " \
                    "AND line.period_id IN ("+ unclosed_period_id + ") "  \
                    "AND (account_account.company_id = %d) ORDER BY line.date" ,
                    (company_id,))
        result_selection = self.cr.dictfetchall()
        return result_selection



    def get_row_data_without_reconcile_line(self,cr,user,startdate,company_id,account_type):
        ##
        cr.execute("SELECT line.* " \
                "FROM account_move_line AS line, account_account " \
                "WHERE (line.account_id = account_account.id) " \
                    "AND (account_account.type IN " + account_type + ") " \
                    "AND ((line.reconcile_id IS NULL) " \
                        "OR (line.reconcile_id IN (SELECT line2.reconcile_id from account_move_line as line2 WHERE line2.date > %s ))) " \
                    "AND line.partner_id IS NOT NULL " \
                    "AND ((line.date <= %s and line.origin_link IS NULL)" \
                        "or (line.id in (select line3.origin_link from account_move_line as line3 where line3.origin_link IS NOT NULL AND line3.date <= %s  ))) "
                    "AND (account_account.company_id = %d) ORDER BY line.date" ,
                    (startdate,startdate,startdate, company_id))
        result_selection = self.cr.dictfetchall()
        return result_selection

    def get_row_data_reconcile_line(self,cr,user,startdate,company_id,account_type):
        ##
        cr.execute("SELECT line.* " \
                "FROM account_move_line AS line, account_account " \
                "WHERE (line.account_id = account_account.id) " \
                    "AND (account_account.type IN " + account_type + ") " \
                    #" AND line.origin_link IS NULL " \
                    "AND line.partner_id IS NOT NULL " \
                    "AND line.date <= %s  " \
                    "AND (account_account.company_id = %d) ORDER BY line.date" ,
                    (startdate,company_id))
        result_selection = self.cr.dictfetchall()
        return result_selection


    
    def get_row_partner_data(self,all_line_tab):
        ## We will extract the partner_id on an other tab
        partner_full_tab = []
        for line in all_line_tab:
            if line['partner_id']:
                partner_full_tab.append(line['partner_id'])
        ## Noew we will remove all duplicate to have a clean list of all partner
        partner_restricted = list(set(partner_full_tab)) 
        return partner_restricted

    def _filtre_partner_in(self,dict_elem):
        
        if self.datas['form'].has_key('fiscalyear'):
            ## We are in a fiscal year content
            if (dict_elem['partner_id'] == self.current_partner_id):
                return dict_elem
        else:        
            if (dict_elem['partner_id'] == self.current_partner_id):
                return dict_elem

    def _filtre_partner_in_and_range(self,dict_elem):
        
        if self.datas['form'].has_key('fiscalyear'):
            ## We are in a fiscal year content
            if (dict_elem['partner_id'] == self.current_partner_id) and (dict_elem['period_id'] in self.datas['form']['periods'][0][2]):
                return dict_elem
        else:        
            if (dict_elem['partner_id'] == self.current_partner_id) and (dict_elem['date'] >= self.datas['form']['date1'] and dict_elem['date'] <= self.datas['form']['date2'] ):
                return dict_elem




    def _filtre_for_solde_init_in(self,dict_elem):
        
        if self.datas['form'].has_key('fiscalyear'):
            ## We are in a fiscal year content
            
            if (dict_elem['partner_id'] == self.current_partner_id) and (dict_elem['period_id'] in self.all_unclosed_period_id_for_that_range):
                return dict_elem
        else:        
            if (dict_elem['partner_id'] == self.current_partner_id) and (dict_elem['date'] < self.datas['form']['date1'] ):
                return dict_elem


    def _sum_function_debit(self,x,y):
        result =x + y['debit']
        return result

    def _sum_function_credit(self,x,y):
        result =x + y['credit']
        return result

    def _get_borne_period(self,cr,context,period_ids):
        if not period_ids:
            period_ids = self.pool.get('account.period').search(self.cr, self.uid, [('fiscalyear_id','=',self.datas['form']['fiscalyear'])])
        result = []
        periods_ids_map = ','.join(map(str,period_ids))
        cr.execute("select period.name from account_period as period where period.date_start = (select min(period2.date_start) from account_period  as period2 where period2.id IN ("+ periods_ids_map + ") AND period2.company_id = "+ str(self.datas['form']['company_id'])+");")
        result_id = self.cr.dictfetchall()
        result.append(result_id)
        cr.execute("select period.name from account_period as period where period.date_stop = (select max(period2.date_start) from account_period  as period2 where period2.id IN ("+ periods_ids_map + ") AND period2.company_id = "+ str(self.datas['form']['company_id'])+");")
        result_id = self.cr.dictfetchall()
        result.append(result_id)
        return result

    def get_template_title(self, cr, context):
      #if self.datas['form'].has_key('fiscalyear'):
      #      result = self._get_borne_period(self.cr,self.uid,self.datas['form']['periods'][0][2])
      #      print str(result)
      #      self.report_title += (_('From')) + str(result[0][0]['name']) + ' ' 
      #      self.report_title += (_('To')) + str(result[1][0]['name']) + ' ' 
      #else:
      #      self.report_title += (_('From')) + str(self.datas['form']['date1']) + ' ' 
      #      self.report_title += (_('To')) + str(self.datas['form']['date2']) + ' ' 
            
            
      if (self.datas['form']['result_selection'] == 'customer' ):
            self.report_title = 'Third Party Ledger / Customer'
      elif (self.datas['form']['result_selection'] == 'supplier'):
            self.report_title = _('Third Party Ledger / Supplier')
      else:
            self.report_title = _('Third Party Ledger / All ')
            
      return self.report_title
 

    def get_story(self):
        story = []
        pool = pooler.get_pool(self.cr.dbname)
        if self.datas['form'].has_key('fiscalyear'):
            ## Variable to store previous unclosed period
            if not self.datas['form']['periods'][0][2] :
                self.datas['form']['periods'][0][2] = self.pool.get('account.period').search(self.cr, self.uid, [('fiscalyear_id','=',self.datas['form']['fiscalyear'])])
        
            self.all_unclosed_period_id_for_that_range = self._get_period_unclosed_fiscal_year(self.cr,self.uid)

        #
        # timebox chart demo
        #
        ## Get maximum and minimum date
        ## We will contruct 
        if (self.datas['form']['result_selection'] == 'customer' ):
            self.ACCOUNT_TYPE = "('receivable')"
        elif (self.datas['form']['result_selection'] == 'supplier'):
            self.ACCOUNT_TYPE = "('payable')"
        else:
            self.ACCOUNT_TYPE = "('payable','receivable')"
        ## Make restriction on result
        if self.datas['form'].has_key('fiscalyear'):
            ## We are in a fiscal year content
            if self.datas['form']['reconcil']:
                ## We will get all lines
                full_result = self.get_row_data_period_reconcile_line(self.cr,self.uid,self.datas['form']['company_id'],self.ACCOUNT_TYPE)
                ## We will nee to have
            else:
                full_result = self.get_row_data_period_without_reconcile_line(self.cr,self.uid,self.datas['form']['company_id'],self.ACCOUNT_TYPE)
        else:
            ## We are in a date content
            if self.datas['form']['reconcil']:
                ## We will get all lines
                full_result = self.get_row_data_reconcile_line(self.cr,self.uid,self.datas['form']['date2'],self.datas['form']['company_id'],self.ACCOUNT_TYPE)
                ## We will nee to have
            else:
                full_result = self.get_row_data_without_reconcile_line(self.cr,self.uid,self.datas['form']['date2'],self.datas['form']['company_id'],self.ACCOUNT_TYPE)
    
        ## Get all partner_concerned
        if (self.datas['model'] == 'res.partner'):
            ## Si on imprime depuis les partenaires
            partner_concerned = self.pool.get('res.partner').browse(self.cr, self.uid,self.ids)
        else:    
            unsorted_partner_id = self.get_row_partner_data(full_result)
            sorted_partner_ids = self.pool.get('res.partner').search(self.cr, self.uid, [('id', 'in',unsorted_partner_id)],order='name')
            partner_concerned = self.pool.get('res.partner').browse(self.cr, self.uid,sorted_partner_ids)
        ###
        for partner in partner_concerned:
            ## 
            ## Create a new table
            self.current_partner_id = partner.id
            partner_in = filter(self._filtre_partner_in,full_result)

            if partner_in:
                partner_in_result_tab = filter(self._filtre_partner_in_and_range,full_result)
                builder = C2cStyleRowsTable(partner.name)
                ## Set informations about period
                #columns
                cumul_balance = 0.0
                builder.add_date_column(_('Date'),width='60', format="%d.%m.%Y")
                builder.add_date_column(_('Due Date'),width='60', format="%d.%m.%Y")
                builder.add_text_column(_('Ref.'),width='150')
                builder.add_text_column(_('Entry Label'))
                builder.add_num_column(_('Debit'),width='80')
                builder.add_num_column(_('Credit'),width='80')
                builder.add_num_column(_('Balance'),width='80')
                builder.add_money_column(_('Amount Currency'),width='80')
                ## Compute Solde init in case of user request
                if self.datas['form']['soldeinit']:
                    all_init_line = filter(self._filtre_for_solde_init_in,full_result)
                    
                    if all_init_line:
                        builder.add_date_cell(None)
                        builder.add_date_cell(None)
                        builder.add_text_cell('')
                        builder.add_text_cell(_('Solde init.'))
                        init_debit = reduce(self._sum_function_debit, all_init_line,0)
                        init_credit = reduce(self._sum_function_credit, all_init_line,0)
                        builder.add_num_cell(init_debit)
                        builder.add_num_cell(init_credit)
                        cumul_balance += (init_debit - init_credit)
                        builder.add_num_cell(cumul_balance)
                        builder.add_num_cell(0.0)
                        
                for line in partner_in_result_tab:   
                    builder.add_date_cell(line['date'])
                    builder.add_date_cell(line['date_maturity'])
                    ## so we send result
                    invoice_ids = self.pool.get('account.invoice').search(self.cr, self.uid, [('move_id','=',line['move_id'])])
                    invoice_obj = self.pool.get('account.invoice').browse(self.cr, self.uid,invoice_ids)
                    if invoice_obj:
                        ref = invoice_obj[0].number
                    else:
                        ref = line['ref']
                    #
                    ##
                    builder.add_text_cell(ref)
                    builder.add_text_cell(line['name'])
                    builder.add_num_cell(line['debit'] or 0.0)
                    builder.add_num_cell(line['credit'] or 0.0)
                    cumul_balance += (line['debit'] - line['credit'])
                    builder.add_num_cell(cumul_balance)
                    if line['amount_currency']:
                        currency_code = self.pool.get('res.currency').browse(self.cr, self.uid,line['currency_id'])
                        builder.add_money_cell(line['amount_currency'] or 0.0,currency=currency_code.code)
                    else:   
                        builder.add_money_cell(line['amount_currency'] or 0.0)
                    
                    
                builder.add_date_cell(None)
                builder.add_date_cell(None)
                builder.add_text_cell('')
                builder.add_text_cell(_('Total'))
                builder.add_subtotal_num_cell()
                builder.add_subtotal_num_cell()
                #
                cell_test = NumCellData(cumul_balance)
                cell_test.font='Helvetica-bold'
                builder.add_custom_cell(cell_test)
                
                builder.add_money_cell(0.0)
        
        ## Add the invoice line table, we put at this place bescause we want to have the resume to be display first
                story.append(Spacer(10,10))
                story.append(builder.get_table())
                ## if the table is more than one and the we nee splitbypartner
                if self.datas['form']['page_split'] and len(partner_concerned) > 1:
                    story.append(PageBreak())
        #
        # We will now get standard informations for this user
        #
        
        return story
    
    
    
c2c_third_party_ledger('report.advanced.third_party_ledgerc2c', 'Aged partner balance','res.partner', StandardReport.A4_LANDSCAPE)        