# -*- coding: utf-8 -*- 
##############################################################################
#
# @author Bessi Nicolas
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import osv, fields
import time
from mx import DateTime
import netsvc
import string


#############################################################################
# We will add a boolean field in order to know if this produuct in sold in a block or not
#############################################################################

class product_product(osv.osv):
	# Add customer name in the case of a changement of partner
	_inherit = "product.product"
	_columns = {
		'hours_blocks': fields.boolean("Manage as block of hour",help='Ckeck this box if this product is sold as a block hour, it will be used when you make invoice of this product to compute the quantity of hours sell for this invoice and the quantity of used '),
	}
product_product()

############################################################################
## Add hours blocks on invoice
############################################################################

class AccountInvoice(osv.osv):
	_inherit = 'account.invoice'
	def _get_hours_blocked_bool(self, cr, uid, ids, name, arg, context={}):
		result = {}
		##
		## We will search invoice line
		hour_blocks_sw = False
		
		for invoice_id in ids:
			invoice_line_ids = self.pool.get('account.invoice.line').search(cr, uid, [('invoice_id', '=', invoice_id)])
			for invoice_line in self.pool.get('account.invoice.line').browse(cr, uid, invoice_line_ids, context):
				if invoice_line.product_id and invoice_line.product_id.hours_blocks:
					hour_blocks_sw = True
			result[invoice_id] = hour_blocks_sw
			hour_blocks_sw = False
		return result
	def _get_hours_buy(self, cr, uid, ids, name, arg, context={}):
		result = {}
		##
		## We will search invoice line
		## Product_quantity
		product_quantity = 0.0
		
		for invoice_id in ids:
			##
			# Get product with hours blocs
			product_ids = self.pool.get('product.product').search(cr, uid, [('hours_blocks', '=', True)])
			
			##
			invoice_line_ids = self.pool.get('account.invoice.line').search(cr, uid, [('invoice_id', '=', invoice_id),('product_id','in',product_ids)])
			for invoice_line in self.pool.get('account.invoice.line').browse(cr, uid, invoice_line_ids, context):
				if invoice_line.product_id and invoice_line.product_id.hours_blocks :
					## We will now calculate the product_quantity
					factor=invoice_line.uos_id.factor
					amount=invoice_line.quantity
					product_quantity = product_quantity + (factor * amount)
			
			result[invoice_id] = product_quantity
			product_quantity = 0.0
		return result

	def _get_hours_used(self, cr, uid, ids, name, arg, context={}):
		result = {}
		##
		## We will search invoice line
		## Product_quantity
		product_quantity = 0.0
		
		for invoice_id in ids:
			#analytic_line_ids = self.pool.get('account.analytic.line').search(cr, uid, [('invoice_id', '=', invoice_id)])
			##
			time_categ_id = self.pool.get('product.uom.categ').search(cr, uid,[('name','=','Temps')])
			time_uom_ids = self.pool.get('product.uom').search(cr, uid,[('category_id','in',time_categ_id)])
			time_map = ','.join(map(str,time_uom_ids))
			##
			#
			cr.execute("select al.id from account_analytic_line as al,account_analytic_journal as aj where aj.id = al.journal_id and aj.type='general' and al.invoice_id = " + str(invoice_id) + " and al.product_uom_id in (" + str(time_map) + ")" )
			ids2 = map(lambda x: x[0], cr.fetchall() or [])
			for analytic_line in self.pool.get('account.analytic.line').browse(cr, uid, ids2, context):
				## We will now calculate the product_quantity
				##factor=analytic_line.product_uom_id and analytic_line.product_uom_id.factor or 1
				if analytic_line.product_uom_id:
					factor= analytic_line.product_uom_id.factor
				else:
					factor = 1
				if analytic_line.to_invoice:
					if analytic_line.to_invoice.factor == 0:
						factor_invoicing = 1
					else:
						factor_invoicing = 1 - analytic_line.to_invoice.factor / 100
				else:
					factor_invoicing = 1
					
				amount=analytic_line.unit_amount
				product_quantity = product_quantity + ((factor * amount) * factor_invoicing)
			result[invoice_id] = product_quantity
			product_quantity = 0.0
		return result

	def _compute_delta(self, cr, uid, ids, name, arg, context={}):
		res = {}
		for pl_line in self.browse(cr, uid, ids):
			res[pl_line.id] =pl_line.amount_hours_blocks-pl_line.amount_hours_blocks_done
		for id in ids:
			res[id] = round(res.get(id, 0.0),2)
		return res

	def _get_last_action(self, cr, uid, ids, name, arg, context={}):
		res = {}
		for id in ids:
			cr.execute('select max(al.date) from account_analytic_line as al where al.invoice_id = ' + str(id))
			ids2 = map(lambda x: x[0], cr.fetchall() or [])
			res[id] = ids2[0]
			
		return res
	def _get_all_hours_blocked(self, cr, uid, obj, name, args):
		
		result = []
		product_ids = self.pool.get('product.product').search(cr, uid, [('hours_blocks', args[0][1], args[0][2])])
		## Search analytic_lines
		invoice_line_ids = self.pool.get('account.invoice.line').search(cr, uid, [('product_id', 'in', product_ids)])
		for invoice_line in self.pool.get('account.invoice.line').browse(cr, uid, invoice_line_ids):
			result.append(invoice_line.invoice_id.id)
		if result:
			return [('id', 'in', result)]
		else:
			return [('id', '=', 0)]




	def _get_delta_hours_blocked(self, cr, uid, obj, name, args):
		
		result = []
		invoice_list_id = self.pool.get('account.invoice').search(cr, uid,[('type','=','out_invoice')])
		invoice_list = self.pool.get('account.invoice').browse(cr,uid,invoice_list_id)
		
		for invoice in invoice_list:
			invoice_product_quantity = 0.0
			analytic_product_quantity = 0.0
			#analytic_line_ids = self.pool.get('account.analytic.line').search(cr, uid, [('invoice_id', '=', invoice.id)])
			##
			time_categ_id = self.pool.get('product.uom.categ').search(cr, uid,[('name','=','Temps')])
			time_uom_ids = self.pool.get('product.uom').search(cr, uid,[('category_id','in',time_categ_id)])
			time_map = ','.join(map(str,time_uom_ids))
			##
			#
			cr.execute("select al.id from account_analytic_line as al,account_analytic_journal as aj where aj.id = al.journal_id and aj.type='general' and al.invoice_id = " + str(invoice.id) + " and al.product_uom_id in (" + str(time_map) + ")" )
			ids2 = map(lambda x: x[0], cr.fetchall() or [])
			#
			##
			
			for analytic_line in self.pool.get('account.analytic.line').browse(cr, uid, ids2):
				## We will now calculate the product_quantity
				if analytic_line.product_uom_id:
					factor= analytic_line.product_uom_id.factor
				else:
					factor = 1
				if analytic_line.to_invoice:
					if analytic_line.to_invoice.factor == 0:
						factor_invoicing = 1
					else:
						factor_invoicing = 1 - analytic_line.to_invoice.factor / 100
				else:
					factor_invoicing = 1
				###print 'Facteur invoice brut ' + str(analytic_line.to_invoice and analytic_line.to_invoice.factor or 99999999) + 'Factueur invoice' +  str(factor_invoicing)
				amount=analytic_line.unit_amount
				analytic_product_quantity = analytic_product_quantity + ((factor * amount) * factor_invoicing)
			###
			product_ids = self.pool.get('product.product').search(cr, uid, [('hours_blocks', '=', True)])

			invoice_line_ids = self.pool.get('account.invoice.line').search(cr, uid, [('invoice_id', '=', invoice.id),('product_id','in',product_ids)])
			for invoice_line in self.pool.get('account.invoice.line').browse(cr, uid, invoice_line_ids):
				if invoice_line.product_id and invoice_line.product_id.hours_blocks :
					## We will now calculate the product_quantity
					factor=invoice_line.uos_id and  invoice_line.uos_id.factor or 0.0
					amount=invoice_line.quantity
					invoice_product_quantity = invoice_product_quantity + (factor * amount)
			if (args[0][1] == '<'):
				if ((invoice_product_quantity - analytic_product_quantity) < float(args[0][2]) ):
					result.append(invoice.id)
			elif (args[0][1] == '>'):
				if ((invoice_product_quantity - analytic_product_quantity) > float(args[0][2]) ):
					result.append(invoice.id)
			elif (args[0][1] == '='):
				if ((invoice_product_quantity - analytic_product_quantity) == float(args[0][2]) ):
					result.append(invoice.id)
			elif (args[0][1] == '<>'):
				if (not (invoice_product_quantity - analytic_product_quantity) == float(args[0][2]) ):
					result.append(invoice.id)
		if result:
			return [('id', 'in', result)]
		else:
			return [('id', '=', 0)]

	_columns = {
		'hours_blocks': fields.function(_get_hours_blocked_bool, method=True, type='boolean', string='Manage as block of hour',store=True,readonly=True,fnct_search=_get_all_hours_blocked, select=1),
		'amount_hours_blocks': fields.function(_get_hours_buy, method=True, type='float', string='Quantity of hours bought',readonly=True, select=1),
		'amount_hours_blocks_done': fields.function(_get_hours_used, method=True, type='float', string='Quantity of hours used',readonly=True, select=1),
		'amount_hours_blocks_delta': fields.function(_compute_delta, method=True, type='float', string='Quantity of hours difference',readonly=True,fnct_search=_get_delta_hours_blocked, select=1),
		'last_action_date' : fields.function(_get_last_action, method=True, type='date', string='Last action taken',readonly=True, select=1),
		'close_date' : fields.date('Closed Date'),
	}

AccountInvoice()




