# -*- coding: utf-8 -*- 
##############################################################################
#
# Copyright (c) 2004 Camptocamp SA
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import osv, fields
import time
from mx import DateTime
import netsvc


#--------------------------------------------------------------------------------------------------------
# Check on timesheet dates interval
#--------------------------------------------------------------------------------------------------------
class hr_timesheet_sheet(osv.osv):
	_inherit = "hr_timesheet_sheet.sheet"

	def _sheet_date(self, cr, uid, ids):
		for sheet in self.browse(cr, uid, ids):
			cr.execute('SELECT id \
					FROM hr_timesheet_sheet_sheet \
					WHERE (date_from < %s and %s < date_to) \
						AND user_id=%d \
						AND id <> %d', (sheet.date_to, sheet.date_from,
							sheet.user_id.id, sheet.id))
			if cr.fetchall():
				return False
		return True
		
	def _date_interval_check(self, cr, uid, ids):
		user = self.pool.get('res.users').browse(cr, uid, uid)
		r = user.company_id.timesheet_range
		res=True
		for sheet in self.browse(cr, uid, ids):
			if r=='month':
				if DateTime.strptime(sheet.date_to, '%Y-%m-%d') <> (DateTime.strptime(sheet.date_from, '%Y-%m-%d') + DateTime.RelativeDateTime(months=+1,day=1,days=-1)):
					res=False
			elif r=='week':
				if DateTime.strptime(sheet.date_to, '%Y-%m-%d') <> (DateTime.strptime(sheet.date_from, '%Y-%m-%d') + DateTime.RelativeDateTime(days=+6,weekday=(DateTime.Sunday,0))):
					res=False
			elif r=='year':
				if DateTime.strptime(sheet.date_to, '%Y-%m-%d') <> time.strftime('%Y-12-31'):
					res=False
		return res

	def on_change_datecurrent(self, cr, uid, ids, date):
		# for sheet in self.browse(cr,uid,id):
		# 	sheet.button_dummy(cr,uid,id,{})
		date_tmp = date
		# logger = netsvc.Logger()
		for sheet in self.browse(cr, uid, ids, {}):
			# logger.notifyChannel("warning", netsvc.LOG_WARNING,
			# 		"No wizard found for the payment type '%s'." % date)
			if DateTime.strptime(date, '%Y-%m-%d') <= DateTime.strptime(sheet.date_from, '%Y-%m-%d'):
				# logger.notifyChannel("warning", netsvc.LOG_WARNING,
				# 		"No wizard found for the payment type '%s'." % date)
				date_tmp=sheet.date_from
				self.write(cr, uid, [sheet.id], {'date_current': sheet.date_from,})
			elif DateTime.strptime(date, '%Y-%m-%d') >= DateTime.strptime(sheet.date_to, '%Y-%m-%d'):
				# logger.notifyChannel("warning", netsvc.LOG_WARNING,
				# 		"No wizard found for the payment type '%s'." % date)
				date_tmp=sheet.date_to
				self.write(cr, uid, [sheet.id], {'date_current': sheet.date_to,})
				
		res={'value':{'date_current':date_tmp}}
		return res
	
	def _date_current_check(self, cr, uid, ids):
		for sheet in self.browse(cr, uid, ids):
			if sheet.date_current < sheet.date_from or sheet.date_current > sheet.date_to:
				return False
		return True


		hr_timesheet_sheet()
	
	_constraints = [
		(_date_interval_check, 'The interval between date from and date to is wrong (must be one week, one month er one year depending to your company settings) !', ['date_from','date_to']),
		(_sheet_date, 'You can not have 2 timesheets that overlaps !', ['date_from','date_to']),
		(_date_current_check, 'You must select a Current date wich is in the timesheet dates !', ['date_current']),
	]

hr_timesheet_sheet()
