import time
from mx import DateTime
import netsvc
from osv import fields
from osv import osv

class hr_expense_line(osv.osv):
	_inherit = "hr.expense.line"
	_description = "Expense Line"
	
	def _famount(self, cr, uid, ids, field_name, arg, context):
		if not len(ids):
			return {}
		id_set = ",".join(map(str, ids))
		cr.execute("""SELECT l.id,COALESCE(SUM(l.foreign_u_price*l.unit_quantity),0) 
			AS amount FROM hr_expense_line l WHERE id IN (%s) GROUP BY l.id """%(id_set))
		res = dict(cr.fetchall())
		return res

	_columns = {

		'currency' : fields.many2one('res.currency',"Currency"),
		'foreign_u_price': fields.float('Foreign unit price'),
		'foreign_total_amount': fields.function(_famount, method=True, string='Foreign Total'),
	}
	
	def on_change_currency(self, cr, uid, id, currency, foreign_u_price, date_value, expense_currency):
		"""Compute the unite price into the company currency"""	
		tmpvalues = self.compute_currency_unit_price(cr,uid, id, currency, foreign_u_price, date_value, expense_currency)	
		return tmpvalues

		
	def on_change_foreign_u_price(self, cr, uid, id, currency, foreign_u_price, date_value, expense_currency):
		tmpvalues = self.compute_currency_unit_price(cr,uid, id, currency, foreign_u_price, date_value, expense_currency)	
		return tmpvalues
	
	def compute_currency_unit_price(self, cr, uid, id, currency, foreign_u_price, date_value, expense_currency):
		"""Compute the unite price into the company currency"""		
		if not expense_currency :
			raise osv.except_osv('Warning !', 'Please enter the expense global currency ')

		if foreign_u_price and currency:
			res_currency_obj = self.pool.get('res.currency')
			converted_u_price = res_currency_obj.compute(cr, uid, currency, expense_currency, foreign_u_price, True, {'date':date_value})
			return {'value': {
				'unit_amount': converted_u_price,
				}}
		else :
			return {}

	
hr_expense_line()

class hr_expense_expense(osv.osv):

	_inherit = "hr.expense.expense"
	def _get_currency_id(self, cr, uid, context={}):
		currency = self.pool.get('res.users').browse(cr, uid, uid, context).company_id.currency_id
		if currency:
			return currency
		else:
			return False
#	_defaults = {
#		'currency_id': _get_currency_id,
#	}
	
	def on_change_expense_currency(self, cr, uid, id, currency, line_ids):
		#if there is a currency
		if currency:
			if not id :
				raise osv.except_osv('Warning !', 'Please save the expense before changing the global expense currency')

			res_currency_obj = self.pool.get('res.currency')
			line_ids_to_return = []
			#we modify the requiered data in the line
			for line in line_ids :
				if line[2]['currency'] and line[2]['foreign_u_price'] :
					converted_u_price = res_currency_obj.compute(cr, uid, 
					line[2]['currency'], 
					currency,
					line[2]['foreign_u_price'], 
					True,
					{'date':line[2]['date_value']})
					
					line[2]['unit_amount']=converted_u_price
					line[2]['expense_id']=id[0]

				#if the expense was allerady saved
				if line[1] :
					try :
						line_ids_to_return.append(line[1])
						self.pool.get('hr.expense.line').write(cr, uid, line[1], line[2], {} )
					except Exception, e:
						tmp_id = self.pool.get('hr.expense.line').create(cr, uid, line[2],{} )
						line_ids_to_return.append(tmp_id)
				else :
					tmp_id = self.pool.get('hr.expense.line').create(cr, uid, line[2],{} )
					line_ids_to_return.append(tmp_id)

						
			return {'value': {
					'line_ids': line_ids_to_return
					}}
		else :
			return {}
hr_expense_expense()

