##############################################################################
#
# Copyright (c) 2005-2007 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import wizard
import pooler

class wizard_adopt_orphans_accounts(wizard.interface):
	_account_orphans_arch = '''<?xml version="1.0"?>
	<form string="All Orphan accounts for your company">
		<field name="accounts" colspan="4" nolabel="1"/>
	</form>'''
	
	_account_orphans_fields = {
			'accounts': {'string': 'Periods', 'type': 'one2many', 'relation': 'account.account', 'help': 'All periods if empty'}
	}

	def _get_defaults(self, cr, uid, data, context):
		## Get the company id of the current user
		user_obj=pooler.get_pool(cr.dbname).get('res.users')
		company=user_obj.browse(cr, uid, uid).company_id
		company_id = company.id
		##
		cr.execute("select ac.id from account_account AS ac where ac.id not in (select child_id from account_account_rel) AND (ac.company_id=%d)" % (company_id))
		res = cr.fetchall() or None
		##
		if res==None:
			## if we have no result we will raise error
			raise wizard.except_wizard('AccountError', 'No Orphans Account')
		
		res = map(lambda x : x[0] , res)
		
		#we get the view id
		mod_obj = pooler.get_pool(cr.dbname).get('ir.model.data')
		act_obj = pooler.get_pool(cr.dbname).get('ir.actions.act_window')
		xml_id = 'action_account_form'
		#we get the model
		result = mod_obj._get_id(cr, uid, 'account', xml_id)
		id = mod_obj.read(cr, uid, result, ['res_id'])['res_id']
		domain=[('id','in',res)]
		# we read the act window
		result = act_obj.read(cr, uid, id)
		result['res_id'] = res
		result['domain'] = domain
		
		return result

	states = {
		'init': {
			'actions': [],
			'result': {'type':'action', 'action':_get_defaults, 'state':'end'},
		},
	}
wizard_adopt_orphans_accounts('account.orphans.accounts')
