# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2008 Camptocamp SA All Rights Reserved.
#
# $Id: sign_in_out.py 2871 2006-04-25 14:08:22Z ged $
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################


import wizard
import netsvc
import time
import pooler
from osv import osv
# from mx import DateTime
from mx.DateTime import RelativeDateTime
import mx.DateTime as custom_mktime 
from datetime import datetime

class wiz_planning_lines_deplace(wizard.interface):
    
    # return computed date_start,date_end
    def _new_date(self,date_start,date_end,day,week,month,new_date_start,new_date_end):
        # Case add day week month
        if not new_date_start and not new_date_end:
            if not day:
                day=0
            if not week:
                week=0
            if not month:
                month=0
            dt_date_start=custom_mktime.mktime((time.strptime(date_start,"%Y-%m-%d")))
            dt_date_end=custom_mktime.mktime((time.strptime(date_end,"%Y-%m-%d")))
            if day <> 0 or week <> 0:
                dt_date_start=dt_date_start+RelativeDateTime(days = int(day)+7*int(week))
                dt_date_end=dt_date_end+RelativeDateTime(days = int(day)+7*int(week))
            if month <> 0:
                dt_date_start=dt_date_start+RelativeDateTime(months=int(month))
                dt_date_end=dt_date_end+RelativeDateTime(months=int(month))
            
            
        elif(new_date_start):
            # New date start to set
            dt_date_start= custom_mktime.mktime(time.strptime(new_date_start,"%Y-%m-%d"))
            # Current value of the line
            date_start = custom_mktime.mktime(time.strptime(date_start,"%Y-%m-%d"))
            date_end=custom_mktime.mktime(time.strptime(date_end,"%Y-%m-%d"))
            # difference between current date end and current date start
            difference_new_minus_old = date_end - date_start
            # New date end = new date_start + difference
            dt_date_end=dt_date_start+difference_new_minus_old
            
            
        elif(new_date_end):
            # New date end to set
            dt_date_end= custom_mktime.mktime(time.strptime(new_date_end,"%Y-%m-%d"))
            # Current value of the line
            date_start = custom_mktime.mktime(time.strptime(date_start,"%Y-%m-%d"))
            date_end=custom_mktime.mktime(time.strptime(date_end,"%Y-%m-%d"))
            # difference between current date end and current date start
            difference_new_minus_old = date_end - date_start
            # New date start = new date_end + difference
            dt_date_start=dt_date_end-difference_new_minus_old
            
        return dt_date_start.strftime("%Y-%m-%d"),dt_date_end.strftime("%Y-%m-%d")
    
    def _move_planning_lines(self, cr, uid, data, context):
        ids = data['ids']
        form = data['form']
        if not ids :
            raise wizard.except_wizard('Warning', 'No planning lines selected.')
        # Test if choose only one of the possibilities, if more than one : 
        # raise error to prevent confusion
        # By possibility means: date_start or date_end or finally by day/week/year
        if (form['day'] or form['week'] or form['month']) and form['new_date_start'] or (form['day'] or form['week'] or form['month']) and form['new_date_end'] or form['new_date_start']  and form['new_date_end']:
            raise wizard.except_wizard('Warning', 'Please choose only one methode to move planning line (define start date or end date or move date start of x days/week/month).')

        # get planning lines
        pool = pooler.get_pool(cr.dbname)
        planning_lines = pool.get('report_account_analytic.planning.line').browse(cr, uid, ids, context)

        line_to_write=[]
        # case move X day/week/month
        if form['day'] or form['week'] or form['month']:
            for line in planning_lines:
                nb_day=form['day']
                nb_week=form['week']
                nb_month=form['month']
                new_start_date,new_end_date=self._new_date(line.date_from,line.date_to,nb_day,nb_week,nb_month,False,False)
                line_to_write.append({'id':line.id,'date_from':new_start_date,'date_to':new_end_date})
                
        # case set date_start
        elif form['new_date_start']:
            for line in planning_lines:
                new_start_date,new_end_date=self._new_date(line.date_from,line.date_to,False,False,False,form['new_date_start'],False)
                line_to_write.append({'id':line.id,'date_from':new_start_date,'date_to':new_end_date})
                
        # case set date_end
        elif form['new_date_end']:
            for line in planning_lines:
                new_start_date,new_end_date=self._new_date(line.date_from,line.date_to,False,False,False,False,form['new_date_end'])
                line_to_write.append({'id':line.id,'date_from':new_start_date,'date_to':new_end_date})
        
        
        for line in line_to_write:
            pool.get('report_account_analytic.planning.line').write(cr, uid, [line['id']], {'date_from':line['date_from'],'date_to':line['date_to']})
        
        return {}
        
    _create_form = """<?xml version="1.0"?>
    <form title="Move planning lines in time" height="200" width="800">
        <label string="Choose one of the following methode:"/>
        <separator string="Set a number of days / week / month to move" colspan="4"/>
        <group colspan="4">
          <field name="day"/>
          <separator/>
          <field name="week"/>
          <field name="month"/>
        </group>
        <separator string="Set fix start date for all lines" colspan="4"/>
        <field name="new_date_start"/>
        <separator string="Set fix end date for all lines" colspan="4"/>
        <field name="new_date_end"/>
    </form>"""

    _create_fields = {
        'new_date_start':  {'string':'New start Date', 'type':'date'},
        'new_date_end': {'string':'New end Date', 'type':'date'},
        'day': {'string':'Day(s) to move', 'type':'integer'},
        'week': {'string':'Week(s) to move', 'type':'integer'},
        'month': {'string':'Month(s) to move', 'type':'integer'},
    }
        
    states = {
    
        'init' : {
            'actions' : [],
            'result' : {'type':'form', 'arch':_create_form, 'fields':_create_fields, 'state': [('end','Cancel'),('movelines','Move lines')]},
        },
        'movelines' : {
            'actions' : [],
            'result' : {'type':'action', 'action':_move_planning_lines, 'state':'end'},
        },

    }
wiz_planning_lines_deplace('move.planning.lines')

# vim:noexpandtab:tw=0
