# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) Camptocamp SA
# Author: Arnaud Wüst
#
#
#    This file is part of the c2c_planning_management module
#
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import wizard
import netsvc
import time
import pooler
from osv import osv

class wiz_workload(wizard.interface):


    def _init_fields(self, cr, uid, data, context):
        """ init the form fields """

        res = {}
        #init dates with start and end dates
        if 'ids' in data:
            min_day = None;
            max_day = None;
            
            for l in pooler.get_pool(cr.dbname).get('report_account_analytic.planning.line').browse(cr, uid, data['ids']):            
                if min_day == None or l.date_from < min_day:
                    min_day = l.date_from
                if max_day == None or l.date_to > max_day:
                    max_day = l.date_to      
                    
            if min_day != None:
                res['date_start'] = min_day
            if max_day != None:
                res['date_end'] = max_day
            
        return res         
    
    _create_form = """<?xml version="1.0"?>
    <form string="Options" height="200" width="200">
        <group colspan="4" col="2" string="Options">
            <field name="scale" />
            <field name="conflicts_only" />
            <separator string="Limits: You can change the report limits" colspan="2"/>        
            <field name="date_start"  />        
            <field name="date_end"  />        
            <separator string="Additional users. Complete the list of users with members of these departments" colspan="2"/>        
            <field name="department" nolabel="1" colspan="2"/>
        </group>
    </form>"""

    _create_fields = {
        'scale' : {'string':'Periods', 'type':'selection', 'type':'selection','selection':[('day','by Days'),('week','by Weeks'),('month','by Months')], 'default':lambda *a: 'day'},
        'conflicts_only' : {'string':'Display only conflicts', 'type':'boolean'},
        'department': {'string':'Departments', 'type':'many2many', 'relation':'hr.department'},
        'date_start':  {'string':'Start Date', 'type':'date','default': lambda *a: time.strftime('%Y-%m-%d')},
        'date_end': {'string':'End Date', 'type':'date'},
    }
        
    states = {
    
        'init' : {
            'actions' : [_init_fields],
            'result' : {'type':'form', 'arch':_create_form, 'fields':_create_fields, 'state': [('end','Cancel'),('print','Display Workload')]},
        },
        
        'print' : {
            'actions': [],
            'result': {'type':'print', 'report':'workload', 'get_id_from_action':False, 'state':'end'},            
        },
    }
wiz_workload('planning.workload')