#!/usr/bin/env python2.3
#
#  print_invoice_list.py
#  PEG
#
#  Created by Nicolas Bessi on 13.10.08.
#  Copyright (c) 2008 CamptoCamp. All rights reserved.
#

import time
from mx.DateTime import *
from report import report_sxw
import xml
import pooler
import re
import xml.dom.minidom
import tools
from osv import osv

class product_obsolete(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(product_obsolete, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'time':time,
            # 'lines': self.lines,
            'comma_me':self.comma_me,
            'get_name_of':self.get_depreciation_name
        })
        self.context = context
         
    def comma_me(self,amount):
        if  type(amount) is float :
            amount = str('%.2f'%amount)
        else :
            amount = str(amount)
        orig = amount
        new = re.sub("^(-?\d+)(\d{3})", "\g<1>'\g<2>", amount)
        if orig == new:
            return new
        else:
            return self.comma_me(new)
            
    def get_depreciation_name(self,value):
        if value=='no':
            return 'No'
        elif value=='half':
            return 'Half'
        elif value=='full':
            return 'Full'
        else:
            return False
            
    def preprocess(self, objects, data, ids):
        # take concerned product
        if data.has_key('ids') and data.has_key('model') and data['ids'] and data['model']=='product.product':
            ids=[data['ids']]
        else:
            ids=self.pool.get('product.product').search(self.cr, self.uid, [('type','=','product')],limit=4000)
        objects=self.pool.get('product.product').browse(self.cr,self.uid,ids)
        def o_compare(x, y):
           if x.outgoing_qty_till_12m<y.outgoing_qty_till_12m:
              return 1
           elif x.outgoing_qty_till_12m==y.outgoing_qty_till_12m:
              return 0
           else: # x<y
              return -1
        # sort object by depreciation 12 month
        objects.sort(o_compare)
        tmp=[]
        for o in objects:
            tmp.append(o.id)
        ids=tmp
        super(product_obsolete, self).preprocess(objects, data, ids)
           
    # def lines(self, form, ids={}, done=None, level=1):
    #         ctx = self.context.copy()
    #         ctx['ref_date']=self.form['to_date']
    #         ctx['location']=self.form['location']
    #         
    #         if not ids:
    #             ids = self.ids
    #         if not ids:
    #             return []
    #         if not done:
    #             done={}
    #         result = []
    #         products = self.pool.get('product.product').browse(self.cr, self.uid, ids, ctx)
    #         
    #         return product

            
report_sxw.report_sxw('report.product.obsolete', 'product.product', 'addons/c2c_stock_obsolete/report/product_obsolete.rml', parser=product_obsolete, header=False)
