# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) Camptocamp SA
# Author: Arnaud Wüst
#
#
#    This file is part of the c2c_planning_management module
#
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import wizard
import netsvc
import time
import pooler
from osv import osv

class wiz_obs(wizard.interface):


    def _init_fields(self, cr, uid, data, context):
        """ init the form fields """
        # get the company location id
        
        mod_obj = pooler.get_pool(cr.dbname).get('ir.model.data')
        stk_obj = pooler.get_pool(cr.dbname).get('stock.location')
        result = mod_obj._get_id(cr, uid, 'stock', 'stock_location_company')
        stock_location_id = mod_obj.read(cr, uid, [result], ['res_id'])[0]['res_id']
        res = {}
        res['location']=stock_location_id
        return res         

    def _open_product(self, cr, uid, data, context):
        pool = pooler.get_pool(cr.dbname)
        domain=''
        # get view
        mod_obj = pooler.get_pool(cr.dbname).get('ir.model.data')
        act_obj = pooler.get_pool(cr.dbname).get('ir.ui.view')
        result = mod_obj._get_id(cr, uid, 'c2c_stock_obsolete', 'product_product_obsolet_tree_view')
        id = mod_obj.read(cr, uid, [result], ['res_id'])[0]['res_id']
        # get child location from location_id
        # build the list of ids of children of the location given by id
        # location_ids = pool.get('stock.location').search(cr, uid, [('location_id', 'child_of', [data['form']['location']])])
        
        # take onyla stockable product type
        domain="[('type','=','product')]"
        if data.has_key('ids') and data.has_key('model') and data['ids'] and data['model']=='product.product':
            product_ids=data['ids']
            domain="[('id','in', ["+','.join(map(str,product_ids))+"]),('type','=','product')]"
        
        value = {
            'domain':domain,
            'name': 'Product obsolescence',
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'product.product',
            'view_id': [id],
            'type': 'ir.actions.act_window',
            'limit':4000,
            'context': "{'ref_date':'%s','location':%s}"%(data['form']['to_date'],data['form']['location'])
        }
        return value
            
    _create_form = """<?xml version="1.0"?>
    <form string="Product obsolescence computation" height="200" width="200">
        <group colspan="4" col="2" string="Options">
            <field name="to_date" />
            <field name="location" />
        </group>
    </form>"""

    _create_fields = {
        'location': {'string':'From location', 'type':'many2one', 'relation':'stock.location','required':'True'},
        'to_date':  {'string':'Obsolescence to date', 'type':'date','required':'True','default': lambda *a: time.strftime('%Y-%m-%d')},
    }
        
    states = {
    
        'init' : {
            'actions' : [_init_fields],
            'result' : {'type':'form', 'arch':_create_form, 'fields':_create_fields, 'state': [('end','Cancel'),('ok','Ok'),('report','Print result')]},
        },
        
        'ok' : {
            'actions': [],
            'result' : {'type':'action', 'action':_open_product, 'state':'end'},      
        },
        'report': {
			'actions': [],
			'result': {'type':'print', 'report':'product.obsolete', 'state':'end'}
		}
    }
wiz_obs('product_obsolescence')
