# -*- coding: iso-8859-1 -*-
##############################################################################
#
# Copyright (c) 2005-2006 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
# Copyright (c) 2008 Camptocamp SA (http://www.camptocamp.com) All Rights Reserved.
# @Author: Aubort Jean-Baptiste
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import wizard
import base64
import os
import osv, tools, pooler, csv
import ir
import netsvc

#=========================
#     TRANSLATE TOOL
# Replace default trans_load_data
# funtion from tools/translate.py
#=========================

def trans_load_data_safe(db_name, data, lang, strict=False, lang_name=None, safe=True):
    logger = netsvc.Logger()
    logger.notifyChannel("init", netsvc.LOG_INFO,
            'loading translation file for language %s' % (lang))
    pool = pooler.get_pool(db_name)
    lang_obj = pool.get('res.lang')
    trans_obj = pool.get('ir.translation')
    model_data_obj = pool.get('ir.model.data')
    try:
        uid = 1
        cr = pooler.get_db(db_name).cursor()
        ids = lang_obj.search(cr, uid, [('code','=',lang)])
        if not ids:
            if not lang_name:
                lang_name=lang
                languages=tools.get_languages()
                if lang in languages:
                    lang_name=languages[lang]
            ids = lang_obj.create(cr, uid, {
                'code': lang,
                'name': lang_name,
                'translatable': 1,
                })
        else:
            lang_obj.write(cr, uid, ids, {'translatable':1})
        lang_ids = lang_obj.search(cr, uid, [])
        langs = lang_obj.read(cr, uid, lang_ids)
        ls = map(lambda x: (x['code'],x['name']), langs)

        ir.ir_set(cr, uid, 'meta', 'lang', 'lang', [('res.users',False,)],
                False, True, False, meta={
                    'type': 'selection',
                    'string': 'Language',
                    'selection':ls,
                    })

        reader = csv.reader(data)
        # read the first line of the file (it contains columns titles)
        for row in reader:
            f = row
            break

        # read the rest of the file
        line = 1
        for row in reader:
            line += 1
            try:
                # skip empty rows and rows where the translation field is empty
                if (not row) or (not row[4]):
                    continue

                # dictionary which holds values for this line of the csv file
                # {'lang': ..., 'type': ..., 'name': ..., 'res_id': ...,
                #  'src': ..., 'value': ...}
                dic = {'lang': lang}
                for i in range(len(f)):
                    dic[f[i]] = row[i]

                try:
                    dic['res_id'] = int(dic['res_id'])
                except:
                    model_data_ids = model_data_obj.search(cr, uid, [
                        ('model', '=', dic['name'].split(',')[0]),
                        ('module', '=', dic['res_id'].split('.', 1)[0]),
                        ('name', '=', dic['res_id'].split('.', 1)[1]),
                        ])
                    if model_data_ids:
                        dic['res_id'] = model_data_obj.browse(cr, uid,
                                model_data_ids[0]).res_id
                    else:
                        dic['res_id'] = False
                if dic['type'] == 'model' and not strict:
                    (model, field) = dic['name'].split(',')

                    # get the ids of the resources of this model which share
                    # the same source
                    obj = pool.get(model)
                    if obj:
                        ids = obj.search(cr, uid, [(field, '=', dic['src'])])

                        # if the resource id (res_id) is in that list, use it,
                        # otherwise use the whole list
                        ids = (dic['res_id'] in ids) and [dic['res_id']] or ids
                        for id in ids:
                            dic['res_id'] = id
                            ids = trans_obj.search(cr, uid, [
                                ('lang', '=', lang),
                                ('type', '=', dic['type']),
                                ('name', '=', dic['name']),
                                ('res_id', '=', dic['res_id'])
                            ])
                            if ids:
                                # Update translation only if not in safe mode
                                if not safe:
                                    trans_obj.write(cr, uid, ids, {'value': dic['value']})
                            else:
                                trans_obj.create(cr, uid, dic)
                else:
                    ids = trans_obj.search(cr, uid, [
                        ('lang', '=', lang),
                        ('type', '=', dic['type']),
                        ('name', '=', dic['name'])
                    ])
                    if ids:
                        # Update translation only if not in safe mode
                        if not safe:
                            trans_obj.write(cr, uid, ids, {'value': dic['value']})
                    else:
                        trans_obj.create(cr, uid, dic)
                cr.commit()
            except Exception, e:
                logger.notifyChannel('init', netsvc.LOG_ERROR,
                        'Import error: %s on line %d: %s!' % (str(e), line, row))
                cr.rollback()
                cr.close()
                cr = pooler.get_db(db_name).cursor()
        cr.close()
        logger.notifyChannel("init", netsvc.LOG_INFO,
                "translation file loaded succesfully")
    except IOError:
        logger.notifyChannel("init", netsvc.LOG_ERROR, "couldn't read file")
