#!/usr/bin/env python2.3
#
#  query_partner.py
#  debugVersion
#
#  Created by Nicolas Bessi on 12.08.08.
#  Copyright (c) 2008 CamptoCamp. All rights reserved.
#
import pooler
import wizard
from tools import UpdateableStr, UpdateableDict

PROF_QUERY_FORM = """<?xml version="1.0"?>
<form string="Query profile">
	<field name="mode" colspan="4"/>
	<field name="query_questions" colspan="4"/>
</form>
"""
DATA_FIELDS = {
	'mode': {'string':"Mode :",'type':'selection','selection':[('AND','AND'),('OR','OR')],'require':'True'},
	'query_questions':{'string': 'Question', 'type': 'one2many', 'relation': 'crm_profiling.query', 'required': True},	
}


def _get_defaults(self, cr, uid, data, context):
	data['form']['mode']= 'AND'
	return data['form']

def _get_partner(self, cr, uid, data, context) :
	form = data['form']
	mode = form['mode']
	if not mode :
		raise wizard.except_wizard('UserError', 'No mode choosen !')

	if form['query_questions'] :
		questions = form['query_questions']
		tmp = []
		for i in questions :
			tmp.append(i[2])
		questions = tmp 
	else :
		return []
	whereclause = _compute_where_clause(cr, uid, questions, mode)
	sql = "SELECT partner FROM partner_question_rel, crm_profiling_answer "+ whereclause
	#print sql
	cr.execute(sql)
	res =  map(lambda x:x[0], cr.fetchall())
	if not res :
		raise wizard.except_wizard('UserError', 'Nothing found.')
	else :
		cr.execute('select id,name from ir_ui_view where model=%s and type=%s', ('res.partner', 'tree'))
		view_res = cr.fetchone()
		return {
		'name': 'Found partners',
		'view_type': 'form',
		'view_mode': 'tree,form',
		'res_model': 'res.partner',
		'view_id': view_res,
		'type': 'ir.actions.act_window',
		'res_id':res
	}
	
	
def _compute_where_clause(cr, uid, questions, mode) :
		sql = ["WHERE partner_question_rel.answer = crm_profiling_answer.id AND crm_profiling_answer.name IS NOT NULL"]
		pool = pooler.get_pool(cr.dbname)
		count = 0
		for quest in questions :
			question_id = quest['question_id']
			operator = quest['operator']
			value = pool.get('crm_profiling.answer').browse(cr, uid, quest['answer_id']).name
			#we try to cast the value into float
			#if it does work we can apply size operator else we ignor the operators
			try :
				float(value) 
				if operator in ('!=','>','<','>=','<=') :
					sql.append('%s (crm_profiling_answer.name %s %s and question_id = %s )'%(mode, operator, value, question_id))
				else :
					sql.append('%s crm_profiling_answer.name %s %s '%(mode, operator, value))
	
			except :
				if operator in ('=','!=') :
					if operator == '!=' :
						sql.append("%s (crm_profiling_answer.name %s '%s'  and question_id = %s ) "%(mode, operator, value, question_id))
					else :
						sql.append("%s crm_profiling_answer.name %s '%s' "%(mode, operator, value))

			
			return ' '.join(sql)
	
	
	
	
class query_profile(wizard.interface):
			
	states = {
		'init': {
				'actions': [_get_defaults],
				'result': {'type':'form', 'arch':PROF_QUERY_FORM, 'fields':DATA_FIELDS, 'state':[('end','Cancel'),('search','Search')]}
		},
		'search' : {
			'actions': [],
			'result': {'type': 'action', 'action': _get_partner, 'state':'end'}
		}
	}
query_profile('queryprofiling')
