# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2008 Sylëam Info Services (http://www.syleam.fr) All rights Reserved.
#                    Christophe Chauvet (christophe.chauvet(at)syleam(dot)fr)
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import fields, osv

def _seq_get(self, cr, uid, context={}):
    cr.execute("SELECT trim(to_char(id,'999999999')) as id, name FROM ir_sequence WHERE code='product.product' ORDER BY name")
    return cr.fetchall()

#----------------------------------------------------------
# Categories
#----------------------------------------------------------
class product_category_sequence(osv.osv):
    '''
    Add a ir.sequence fields on category
    '''
    _inherit = 'product.category'

    _columns = {
        'product_seq': fields.selection(_seq_get, 'Product Sequence', size=64),
    }

product_category_sequence()

#----------------------------------------------------------
# Products
#----------------------------------------------------------
class product_code_category(osv.osv):
    '''
    Add sequence on product on create with sequence 
    assign by category
    '''
    _inherit = 'product.product'
    
    def create(self, cr, uid, vals, context={}):
        if not vals['default_code']:
            vals['default_code'] = self._get_seq(cr, uid, vals['categ_id'], context)
        res = super(product_code_category, self).create(cr, uid, vals, context)
        return res

    def _get_seq(self, cr, uid, cat_id, context):
        parent = True
        while parent != False:
            categ = self.pool.get('product.category').read(cr, uid, [cat_id], ['product_seq', 'parent_id'])
            category = categ[0]
            if category['product_seq']:
                break
            
            if not category['parent_id']:
                cat_id = False
            else:
                cat_id = category['parent_id'][0]
            parent = cat_id

        sequence_obj = self.pool.get('ir.sequence')
        if category['product_seq']:
            res = sequence_obj.get_id(cr, uid, int(category['product_seq']))
        else:
            seq = sequence_obj.search(cr, uid, [('name','=','Default Product Code')])
            res = sequence_obj.get_id(cr, uid, int(seq[0]))
        return res

product_code_category()

