##############################################################################
#
# Copyright (c) 2005-2006 TINY SPRL. (http://tiny.be) All Rights Reserved.
#
# $Id: make_invoice.py 1070 2005-07-29 12:41:24Z nicoe $
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import wizard
import netsvc
import pooler
import math
import mx.DateTime
from mx.DateTime import RelativeDateTime, now, DateTime, localtime

period_form = """<?xml version="1.0"?>
 <form string="Stock Periods">
                    <separator colspan="4" string="Create periods for Sale Planning"/>
                    <field name="date_start"/>
                    <newline/>
                    <field name="date_stop"/>
 </form>
"""

period_fields = {
    'date_start': {'string':'Start Date', 'type':'date', 'required':True},
    'date_stop': {'string':'End Date', 'type':'date', 'required':True}
}

def _set_default(self, cr, uid, data, context=None):
    cr.execute("select max(date_stop) from stock_period")
    result = cr.fetchone()
    period_fields['date_start']['default'] = result and result[0] or ''
    return {}

class create_period(wizard.interface):
    def create_period_weekly(self,cr, uid, datas, context={}):
        res=self.create_period(cr, uid, datas, context, 6, 'Weekly')
        return {
                'view_type': 'form',
                "view_mode": 'tree',
                'res_model': 'stock.period',
                'type': 'ir.actions.act_window',
            }

    def create_period_monthly(self,cr, uid, datas, context={},interval=1): 
        date_start=datas['form']['date_start']
        date_stop=datas['form']['date_stop']
        dt = date_start
        ds = mx.DateTime.strptime(date_start, '%Y-%m-%d')
        while ds.strftime('%Y-%m-%d')<date_stop:
            de = ds + RelativeDateTime(months=interval, days=-1)
            pooler.get_pool(cr.dbname).get('stock.period').create(cr, uid, {
                'name': ds.strftime('%Y/%m'),
                'date_start': ds.strftime('%Y-%m-%d'),
                'date_stop': de.strftime('%Y-%m-%d'),
            })
            ds = ds + RelativeDateTime(months=interval)
        return {
                'view_type': 'form',
                "view_mode": 'tree',
                'res_model': 'stock.period',
                'type': 'ir.actions.act_window',
            }

    def create_period(self,cr, uid, datas, context={},interval=0, name='Daily'):        
        date_start=datas['form']['date_start']
        date_stop=datas['form']['date_stop']
        dt = date_start
        ds = mx.DateTime.strptime(date_start, '%Y-%m-%d')
        while ds.strftime('%Y-%m-%d')<date_stop:
            de = ds + RelativeDateTime(days=interval)
            if name=='Daily':
                new_name=de.strftime('%Y-%m-%d')
            if name=="Weekly":
                new_name=de.strftime('%Y, week %W')
            pooler.get_pool(cr.dbname).get('stock.period').create(cr, uid, {
                'name': new_name,
                'date_start': ds.strftime('%Y-%m-%d'),
                'date_stop': de.strftime('%Y-%m-%d'),
            })
            ds = ds + RelativeDateTime(days=interval) + 1
        return {
                'view_type': 'form',
                "view_mode": 'tree',
                'res_model': 'stock.period',
                'type': 'ir.actions.act_window',
            }
    
    states = {
        'init' : {
            'actions' : [_set_default],
            'result' : {'type' : 'form',
                    'arch' : period_form,
                    'fields' : period_fields,
                    'state' : [('daily', 'Create Daily Periods'),('weekly', 'Create Weekly Periods'),('monthly', 'Create Monthly Periods')]}
                    },
          'daily':{
            'actions' : [],
            'result' : {'type' : 'action',
                    'action' : create_period,
                    'state' : 'end'}
                  },
          'weekly':{
            'actions' : [],
            'result' : {'type' : 'action',
                    'action' : create_period_weekly,
                    'state' : 'end'}
                   },
          'monthly':{
            'actions' : [],
            'result' : {'type' : 'action',
                    'action' : create_period_monthly,
                    'state' : 'end'}
                    }
         }
create_period("stock.planning.period.create_period")
