# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2005 Sylëam Info Services. (http://www.syleam.fr) All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import pooler
import wizard
from osv import osv

form_gencod = """<?xml version="1.0"?>
<form string="Scan product">
<label string="Scan gencod" colspan="4"/>
<field name="gencod" colspan="4" nolabel="1"/>
</form>
"""

fields_gencod = {
    'gencod': {'string': 'Gencod',
               'type': 'char',
               'size': 13,
               'required': True}
}


def _scan(self, cr, uid, data, context):
    print str(data)
    pool = pooler.get_pool(cr.dbname)
    result = pool.get('pos.order.line')._scan_product(cr, uid, data['form']['gencod'], 1, data['id'])
    print "RETURN: "+str(result)
    return {'gencod': False}

def _pre_init(self, cr, uid, data, context):
    return {'gencod': False}

class pos_scan_product(wizard.interface):
    states = {
        'init' : {'actions' : [_pre_init],
                'result' : {
                    'type': 'form',
                    'arch': form_gencod,
                    'fields': fields_gencod,
                    'state': [('end','Cancel','gtk-cancel'),
                              ('add', 'Add', 'gtk-ok', True)],
            }
        },
        'add' : {'actions' : [_scan],
                'result' : {
                    'type': 'state',
                    'state': 'init',
                }
        }
    }

pos_scan_product('pos.scan_product')

